'use strict';

$.errorMsg = {
	tel: {
		incorrect: '手机号码格式不正确',
		int_error: '推荐人手机号码格式不正确',
		none: '请输入手机号码',
		leng: '请输入11位手机号码'
	},
	picCert: {
		none: '请输入验证码'
	},
	token: {
		none: '请输入短信验证码',
		error: '短信验证码不正确'
	},
	system: {
		timeout: '对不起，系统繁忙，请稍后再试',
		msg: '抱歉，页面出现错误。'
	},
	emergency: {
		name_none: '紧急联系人姓名不能为空',
		name_lang: '紧急联系人姓名长度不能超过100个字符',
		phone_none: '紧急联系人电话不能为空'
	},
	email: {
		incorrect: '您输入的邮箱不符合要求',
		none: '请输入您的集团邮箱',
		nonePerson: '请输入您的个人邮箱',
		noneAsset: '请输入接收资产证明的邮箱',
		token: '请输入验证码',
		error: '验证码错误'
	},
	risk: {
		none: '未完成全部题目'
	},
	trade_password: {
		incorrect: '请输入6位数字',
		none: '请输入交易密码',
		old_incorrect: '当前交易密码为6位数字',
		old_none: '请输入当前交易密码',
		new_incorrect: '新交易为6位数字',
		new_none: '请输入新交易密码',
		trade_password_none: '请先设置交易密码'
	},
	login_passwd: {
		incorrect: '登录密码至少为8位数字字母字符组合',
		incorrect_reg: '请设置为8~20位数字字母组合密码',
		illge: '特殊字符仅可使用~\.\!@#\$\%\^&\*',
		none: '请输入登录密码',
		old_none: '请输入当前登录密码',
		old_err: '当前登录密码为8~20位',
		length_err: '新登录密码至少为8位数字字母字符组合'
	},
	confirm_passwd: {
		incorrect: '两次输入不一致，请重新输入',
		same: '新密码不能与原密码相同'
	},
	idNo: {
		none: '请输入证件号码',
		error: '身份证格式不正确'
	},
	idtype: {
		none: '请选择证件类型'
	},
	name: {
		none: '请输入您的姓名'
	},
	bank: {
		none: '请选择银行',
		province_none: '请选择开户行所在省份',
		city_none: '请选择开户行所在城市',
		banch_none: '请输入开户行名称'
	},
	card: {
		none: '请输入银行卡号',
		error: '申购金额超出银行卡支付限额，请修改金额或换卡支付',
		error2: '申购金额超出银行卡支付限额，请换卡支付',
		bank_not_match: '银行卡号与所选择的银行不匹配',
		no_card: '请先绑定一张银行卡'
	},
	verified: {
		error: '已认证',
		idVerified_none: '请完成实名认证并设置交易密码'
	},
	companyVerified: {
		error: '已认证',
		companyVerified_none: '请先完成员工认证'
	},
	amount: {
		purchase_none: '请输入您要申购的金额',
		redem_none: '请输入赎回金额',
		incorrect: '请输入正确的金额',
		purchase_big_bank: '申购金额超出银行卡支付限额',
		redem_big: '赎回金额不能超过可赎回金额',
		big_currency: '赎回金额不能大于当前持有总额',
		purchase_min_error: function(amount){
			return '请至少购买'+amount+'元';
		},
		purchase_step_error:  function(amount){
			return '请增加'+amount+'的整数倍';
		},
		small_hold: function(amount){
			return '剩余金额小于'+amount+'元，请全部赎回';
		},
		small_limit: function(amount){
			return '赎回金额不得小于'+amount+'元';
		},
		dot: '购买金额必须为1元的整数倍',
		purchase_payMethod_none: '请选择支付方式',
		purchase_payMethod_mix: '首次购买不能同时使用银行卡和天玑宝支付',
		purchase_big_acct_bank: '投资金额过大，天玑宝可用金额和银行卡无法支付',
		purchase_big_acct: '投资金额大于天玑宝可用金额',
		step_1W: '10000',
		step_1W_error: '请至少购买10,000元',
		purchase_remain_error: function(amount){
			return '该产品剩余'+amount+'元可购买';
		},
		purchase_max_error:  function(amount){
			return '本次最多可支付：'+amount+'元';
		}
	},
	rate: {
		none: '请设置转让利率',
		error: '请输入数字',
		big: function(rate){
			return '转让利率不能超过'+rate+'%';
		},
		small: function(rate){
			return '转让利率不能低于'+rate+'%';
		},
		incorrect:'小数点后最多保留两位'
	},
	phone_passwd: {
		incorrect: '请输入6位数字',
		none: '请输入手势密码',
		old_none: '请输入原手势密码',
		old_incorrect: '原手势密码为6位数字',
		new_none: '请输入新手势密码',
		new_incorrect: '新手势密码为6位数字',
		err: '您输入的手势密码错误'
	},
	purchase:{
		err: '可能失败的原因如下：1、超出银行规定的支付限额；2、超出您设置的网银支付限额'
	},
	share: {
		incorrect: '请输入正确的份额',
		transfer_min_error: function(amount){
			return '请至少转让'+amount+'份';
		},
		transfer_min_hold: function(amount){
			return '转让后剩余份额低于'+amount+'份必须全部转让';
		},
		transfer_step_error:  function(amount){
			return '请转让'+amount+'的整数倍';
		},
		transfer_big: '转让份额大于可转让份额'
	},
	contact: {
		province_none: '请选择省份',
		city_none: '请选择市/区',
		address_none: '请输入详细地址',
		profession_none: '请选择职业类型'
	},
	coupon: {
		inUse:  function(minuts){
			return '优惠券正在使用中，如未成功，'+minuts+'分钟后会自动退回账户'
		},
		inUseNoTime: '优惠券正在使用中，如未成功，会自动退回账户'
	},
	ocr: {
		noIdTypeA: '请先扫描身份证正面',
		noIdTypeB: '请先扫描身份证背面'
	}
};