Handlebars.registerHelper('compare', function(left, operator, right, options) {
  if (arguments.length < 3) {
    throw new Error('Handlerbars Helper "compare" needs 2 parameters');
  }
  var operators = {
    '==':     function(l, r) {return l == r; },
    '===':    function(l, r) {return l === r; },
    '!=':     function(l, r) {return l != r; },
    '!==':    function(l, r) {return l !== r; },
    '<':      function(l, r) {return l < r; },
    '>':      function(l, r) {return l > r; },
    '<=':     function(l, r) {return l <= r; },
    '>=':     function(l, r) {return l >= r; },
    'typeof': function(l, r) {return typeof l == r; }
  };

  if (!operators[operator]) {
    throw new Error('Handlerbars Helper "compare" doesn\'t know the operator ' + operator);
  }

  var result = operators[operator](left, right);

  if (result) {
    return options.fn(this);
  } else {
    return options.inverse(this);
  }
});

Handlebars.registerHelper('toStdAmount', function(num, options) {
  	if(isNaN((num+"").replace(/,/g,""))){
		return (num);
	}else{
		var numArr = (num+"").replace(/,/g,"").split(".");
		var str = numArr[0];
		while(/(\d+)(\d{3})/.test(str)){
			str = str.replace(/(\d+)(\d{3})/, '$1' + ',' + '$2');
		}
		if(numArr.length === 1){
			return (str+".00");
		} else if(numArr.length === 2){
			if((numArr[1] + "").length === 1){
				return (str +'.' + numArr[1] + "0");
			} else {
				return (str +'.' + (numArr[1] + "").substr(0,2));
			}
		}
	}
});

Handlebars.registerHelper('keepTwoDecimal', function(num, options) {
	if (typeof(num)=="string") {
		num = parseFloat(num); 
	} else if (isNaN(num)) {
		return '数据错误';
	}
    var num = Math.round(num*100)/100;    
    var s = num.toString();    
    var rs = s.indexOf('.');    
    if (rs < 0) {    
        rs = s.length;    
        s += '.';    
    }
    while (s.length <= rs + 2) {    
        s += '0';    
    }
    return s;
});