'use strict';
//定义requestAnimationFrame
var rAF = window.requestAnimationFrame ||
    window.webkitRequestAnimationFrame ||
    window.mozRequestAnimationFrame ||
    window.oRequestAnimationFrame ||
    window.msRequestAnimationFrame ||
    function(callback) { window.setTimeout(callback, 1000 / 60); };
//prevent default
$.preventDefault = function(e) {
    e.preventDefault();
};
//定义全局变量
$.touchMoved = false; //touchmove判断
$.globalEffect = 0; //全局动画效果开关，1为开启，0为关闭
$.globalAnimateSpeed = 0; //全局js动画时长
$.isjq; //引用库名判断
$.fnScrollPanelTimeOut; //滚动面板用
$.orientationTimeout; //旋转超时
$.fnNoticeShowTimeOut; //消息提示用
$.fnNoticeHideTimeOut; //消息提示用
$.fnNoticeDestoryTimeOut; //消息提示用
$.winW = $(window).width(); //定义窗口宽
$.winH = $(window).height(); //定义窗口高
$.winResizeLock; //定义窗口resize lock
$.fontSize = 0; //定义动态fontsize
$.htmlBody; //定义body
$.amHeader; //定义am-header
$.amFooter; //定义am-footer
$.ambody; //定义am-body
$.ambodyInner; //定义am-bodyInner
$.ambodyScroll; //定义scrollInner
$.sTop = 0; //定义滚动条高度
$.xIndex = 0; //定义横向当前项
$.xPage = []; //定义横向页码
$.pullDownSensitive = 70; //定义下拉阀值
$.pullUpSensitive = 20; //定义上拉阀值
$.pullDownHtml = "<div class='am-pullDown'><span></span><span></span><span></span></div>"; //上拉加载dom
$.pullUpHtml = "<div class='am-pullUp'><span class='icon'></span><span class='msg'></span></div>"; //下拉刷新dom
$.scrollX = []; //全局横向滚动条数组
$.scrollY = []; //全局纵向滚动条数组
$.bounceTime = 600; //下拉刷新回弹时间，须大于550ms
$.touchX; //touch触点X
$.touchY; //touch触点Y
$.config = {
    language: (navigator.browserLanguage || navigator.language).toLowerCase(),
    //检测操作系统
    system: function() {
        var p = navigator.platform.toLowerCase();
        var u = navigator.userAgent.toLowerCase();
        return {
            win: p === "win32" || p === "win64" || p === "windows",
            mac: p === "mac68k" || p === "macppc" || p === "macintosh" || p === "macintel",
            linux: p === "linux" || p === "x11",
            ios: !!u.match(/\(i[^;]+;( u;)? cpu.+mac os x/),
            android: u.indexOf('android') > -1 || u.indexOf('linux') > -1
        };
    }(),
    //检测操作系统版本，返回结果为数值型，格式为整数加.加n位小数，
    version: function() {
        var u = navigator.userAgent.toLowerCase();
        var vv = "";
        var vs = -1; //version start
        var ve = -1; //version end
        var tt = -1; //temp text
        switch (true) {
            case u.indexOf('msie') > 1:
                vs = u.indexOf('msie') + 5;
                tt = u.substr(vs);
                ve = tt.indexOf(';');
                break;
            case u.indexOf('windows nt') > 1:
                vs = u.indexOf('windows nt') + 11;
                tt = u.substr(vs);
                ve = tt.indexOf(';');
                break;
            case u.indexOf('iphone os') > 1:
                vs = u.indexOf('iphone os') + 10;
                tt = u.substr(vs);
                ve = tt.indexOf('like') - 1;
                break;
            case u.indexOf('cpu os') > 1:
                vs = u.indexOf('cpu os') + 7;
                tt = u.substr(vs);
                ve = tt.indexOf('like') - 1;
                break;
            case u.indexOf('android') > 1:
                vs = u.indexOf('android') + 8;
                tt = u.substr(vs);
                ve = tt.indexOf(';');
                break;
            case u.indexOf('(bb') > 1:
                vs = u.indexOf('(bb') + 3;
                tt = u.substr(vs);
                ve = tt.indexOf(';');
                break;
        }
        var t = u.substr(vs, ve).replace(/_/g, '.').split(".");
        for (var i = 0; i < t.length; i++) {
            if (i === 0 && t.length > 1) {
                vv += String(t[i]) + ".";
            } else {
                vv += String(t[i]);
            }
        }
        return Number(vv) || -1;
    }(),
    //检测浏览器
    browser: function() {
        var u = navigator.userAgent.toLowerCase();
        return {
            msie: u.indexOf("msie") > -1 || u.indexOf("rv:11") > -1,
            edge: u.indexOf("edge") > -1,
            trident: u.indexOf('trident') > -1,
            presto: u.indexOf('presto') > -1,
            webKit: u.indexOf('applewebKit') > -1,
            firefox: u.indexOf('firefox') > -1,
            chrome: u.indexOf('chrome') > -1,
            opera: u.indexOf('opera') > -1 && u.indexOf('chrome') < 1,
            safari: u.indexOf('safari') > -1 && u.indexOf('chrome') < 1,
            gecko: u.indexOf('gecko') > -1 && u.indexOf('khtml') < 1,
            mobile: !!u.match(/applewebkit.*mobile.*/) || !!u.match(/applewebkit/),
            iPhone: u.indexOf('iphone') > -1,
            iPad: u.indexOf('ipad') > -1,
            webApp: u.indexOf('safari') < 1,
            wechat: u.match(/micromessenger/i) === "micromessenger"
        };
    }()
}; //检测系统参数
$.settouch = {
    init: function setTouch(e) {
        if (typeof(jQuery) !== "undefined") {
            $.touchX = e.originalEvent.changedTouches[0].pageX;
            $.touchY = e.originalEvent.changedTouches[0].pageY;
        } else {
            $.touchX = e.targetTouches[0].pageX;
            $.touchY = e.targetTouches[0].pageY;
        }
    }
}; //检测jQuery或Zepto引用，设置touch触点
$.setmove = {
    init: function() {
        $(document).off("touchstart.touchmove").on("touchstart.touchmove", this.move);
        $(document).off("touchmove.touchmove").on("touchmove.touchmove", this.move);
        $(document).off("touchend.touchmove").on("touchend.touchmove", this.move);
    },
    move: function(e) {
        if (e.type === "touchstart") {
            $.touchMoved = false;
            $.settouch.init(e);
            $.setmove._x = $.touchX;
            $.setmove._y = $.touchY;
        } else if (e.type === "touchmove") {
            $.settouch.init(e);
            var _x = $.touchX;
            var _y = $.touchY;
            if (Math.abs(_x - $.setmove._x) > 10 || Math.abs(_y - $.setmove._y) > 10) {
                $.touchMoved = true;
            }
        } else if (e.type === "touchend") {
            $.touchMoved = false;
        }
    }
}; //检测Touch后是否移动

//fnTitleToTop
$.fn.fnTitleToTop = function() {
    if (!$(this).length) return;
    var $this = $(this);
    init();

    function init() {
        //绑定标题点击事件
        $this.off("touchend.titletotop").on("touchend.titletotop", fnTitleClick);
    }

    //标题点击事件
    function fnTitleClick(e) {
        //判断当前纵向滚动条是否不在顶部 && 是否有点击移动 && 是否正在pageload
        if ($.scrollY[$.xIndex].y < 0 && !$.touchmoved && !$(".am-pageload").length) {
            $.scrollY[$.xIndex].scrollTop();
        }
    }
};

//fnAutoTitle
$.fn.fnAutoTitle = function() {
    if (!$(this).length) return;

    var $this = $(this);
    var size = parseInt($this.css("font-size"));
    var titleText = $this.text();
    var titleHeight = 46;
    init();

    //初始化标题处理
    function init() {
        if ($this.height() <= titleHeight) {
            $this.addClass("am-on");
        } else {
            fnSetSize();
        }
    }

    //字号缩小处理
    function fnSetSize() {
        size -= 1; //每次递减字号
        $this.css({
            "font-size": size + "px"
        });
        if ($this.height() > titleHeight && size > $.fontSize) {
            fnSetSize();
        } else if ($this.height() > titleHeight) {
            fnSetLength();
        } else {
            $this.addClass("am-on");
        }
    }

    //删减尾字符处理
    function fnSetLength() {
        if ($this.height() > titleHeight) {
            titleText = titleText.substring(0, $this.text().length - 1);
            $this.text(titleText);
            fnSetLength();
        }
        //最后一次删减后去掉3位补"..."
        else {
            titleText = titleText.substring(0, $this.text().length - 3);
            $this.text(titleText + "...");
            $this.addClass("am-on");
        }
    }
};

//fnClipPic
$.fn.fnClipPic = function(options) {
    if (!$("#pic").length) return;

    var defaults = {
        onFinish: function(x, y, w, h) {}
    };
    var opt = $.extend({}, defaults, options);
    var $this = $("#pic");
    $this.height($this.width()); //显示区域
    var $img = $this.find("img"); //移动的图片
    var iw = $img.width();
    var ih = $img.height();
    var $btn = $("#btnClipPic");
    var bw = $this.width();
    var bh = $this.width();
    var bl = $this.offset().left;
    var bt = $this.offset().top; //显示区域宽高左上
    var oh, ow, ol, ot, _ow, _oh; //图片宽高左上，图片原始左上
    var x0, _x0, y0, _y0; //_x0横向距离obj边缘||x0新的左边距
    var x1, _x1, y1, _y1; //同上
    var xc, yc, mxc, myc; //双指中心xy,及xy位移
    var xx, yy, zz, _zz; //xyz三边长度，_zz斜边原始长度
    var scale = 1;
    var _scale = 1;
    var scaleX, scaleY, scaleO; //放大比例，上次比例，中心点横向比例，中心点纵向比例
    init();

    function init() {
        $img.on("touchstart.clippic", fnTouchStart).on("touchend.clippic", fnTouchEnd);
        $btn.off("touchend.clippic").on("touchend.clippic", fnBtnFinish);
        fnAutoCenter();
    }

    //初始自适应居中
    function fnAutoCenter() {
        //图片宽高比小于窗口宽高比
        if ($img.width() / $img.height() < bw / bh) {
            //计算宽高
            ow = _ow = bw; //宽度固定
            oh = "auto"; //高度自适应
            //设置宽高
            $img.css({
                height: oh,
                width: ow
            });
            //计算居中
            ot = (bh - $img.height()) / 2;
            ol = 0;
            //设置居中
            $img.css({
                top: ot,
                left: ol
            });
            //计算偏移值
            oh = _oh = $img.height();
            scaleO = iw / bw;
            x0 = ol;
            y0 = ot;
        }
        //大于
        else {
            //计算宽高
            oh = _oh = bh; //高度固定
            ow = "auto"; //宽度自适应
            //设置宽高
            $img.css({
                height: oh,
                width: ow
            });
            //计算居中
            ol = (bw - $img.width()) / 2;
            ot = 0;
            //设置居中
            $img.css({
                top: ot,
                left: ol
            });
            //计算偏移值
            ow = _ow = $img.width();
            scaleO = ih / bh;
            x0 = ol;
            y0 = ot;
        }
    }

    //目标区域开始点击事件
    function fnTouchStart(e) {
        //双指点击
        if (e.targetTouches[1]) {
            //第一手指
            var touch0 = e.targetTouches[0];
            _x0 = Math.ceil(Number(touch0.pageX - $img.position().left));
            _y0 = Math.ceil(Number(touch0.pageY - $img.position().top));
            //第二手指
            var touch1 = e.targetTouches[1];
            _x1 = Math.ceil(Number(touch1.pageX - $img.position().left));
            _y1 = Math.ceil(Number(touch1.pageY - $img.position().top));
            //计算双指中心点
            xc = Math.ceil(Math.abs(((touch1.pageX - bl) + (touch0.pageX - bl)) / 2));
            yc = Math.ceil(Math.abs(((touch1.pageY - bt) + (touch0.pageY - bt)) / 2));
            //计算枞横定位及缩放比
            mxc = xc - $img.position().left;
            myc = yc - $img.position().top;
            scaleX = mxc / ow;
            scaleY = myc / oh;
            //缩放初始值
            xx = ((touch1.pageX - bl) - (touch0.pageX - bl));
            yy = ((touch1.pageY - bt) - (touch0.pageY - bt));
            _zz = Math.sqrt(Math.pow(xx, 2) + Math.pow(yy, 2));

        }
        //单指点击
        else
        if (e.targetTouches[0]) {
            var touch0 = e.targetTouches[0];
            _x0 = Math.ceil(Number(touch0.pageX - $img.position().left));
            _y0 = Math.ceil(Number(touch0.pageY - $img.position().top));
        }
        //绑定移动
        $img.on("touchmove.clippic", fnTouchMove);
    }

    //目标区域内移动事件
    function fnTouchMove(e) {
        //双指移动
        if (e.targetTouches[1]) {
            var touch0 = e.targetTouches[0];
            var touch1 = e.targetTouches[1];
            x0 = Math.ceil(Number(touch0.pageX) - _x0);
            y0 = Math.ceil(Number(touch0.pageY) - _y0);
            x1 = Math.ceil(Number(touch1.pageX) - _x1);
            y1 = Math.ceil(Number(touch1.pageY) - _y1);
            xc = Math.ceil(((touch1.pageX - bl) + (touch0.pageX - bl)) / 2);
            yc = Math.ceil(((touch1.pageY - bt) + (touch0.pageY - bt)) / 2);
            //缩放变化值
            xx = ((touch1.pageX - bl) - (touch0.pageX - bl));
            yy = ((touch1.pageY - bt) - (touch0.pageY - bt));
            zz = Math.sqrt(Math.pow(xx, 2) + Math.pow(yy, 2));
            //缩放比，最大放大4倍
            scale = zz / _zz * _scale;
            if (scale < 1) {
                scale = 1;
            } else if (scale > 4) {
                scale = 4;
            }
            //缩放后左上边距
            x0 = xc - Math.ceil(_ow * scale * scaleX);
            y0 = yc - Math.ceil(_oh * scale * scaleY);
        } else
        //单指移动
        if (e.targetTouches[0]) {
            var touch0 = e.targetTouches[0];
            x0 = Math.ceil(Number(touch0.pageX) - _x0);
            y0 = Math.ceil(Number(touch0.pageY) - _y0);
        }
        //设置四边限位,带入缩放比
        if (x0 > 0) {
            x0 = 0;
        } else if (x0 < bw - _ow * scale) {
            x0 = bw - _ow * scale;
        }
        if (y0 > 0) {
            y0 = 0;
        } else if (y0 < bh - _oh * scale) {
            y0 = bh - _oh * scale;
        }
        //设置图片位置及尺寸
        $img.css({
            left: x0,
            top: y0,
            width: _ow * scale,
            height: _oh * scale
        });
    }

    //目标区别结束点击事件
    function fnTouchEnd() {
        //双指移动后又抬起一指，会有跳动
        $img.off("touchmove.clippic");
        //隐藏双指中心
        //$(".fingerC").hide();
        //更新图片宽高和缩放比
        oh = $img.height();
        ow = $img.width();
        _scale = scale;
    }

    //返回处理结果按钮点击事件
    function fnBtnFinish() {
        var x = Math.round(x0 * scaleO / scale);
        var y = Math.round(y0 * scaleO / scale);
        var w = Math.round(bw * scaleO / scale);
        var h = Math.round(bh * scaleO / scale);
        //call back
        opt.onFinish(x, y, w, h);
    }
};

//fnEyeNumber
$.fn.fnEyeNumber = function(options) {
    if (!$(".am-icon-eye-w").eq(0).length) return;
    var defaults = {
        isOpen: true,
        onChanged: function() {}
    };
    var opt = $.extend({}, defaults, options);
    var $this = $(".am-icon-eye-w").eq(0);
    init();

    function init() {
        //遍历需要关闭的数据
        $(".am-eye-number").each(function() {
            if ($.trim($(this).text()) !== "****") {
                $(this).attr({
                    "data-number": $(this).text()
                });
            }
        });

        //设置初始状态
        if (opt.isOpen) {
            fnEyeOpen();
        } else {
            fnEyeClose();
        }

        //绑定事件
        $this.off("touchend.eyenumber").on("touchend.eyenumber", function() {
            if (!$.touchMoved) {
                if ($this.hasClass("am-on")) {
                    fnEyeClose();
                    opt.isOpen = false;
                } else {
                    fnEyeOpen();
                    opt.isOpen = true;
                }
                //call back
                opt.onChanged(opt.isOpen);
            }
        });
    }

    //眼睛打开事件
    function fnEyeOpen() {
        //设置眼睛图标打开样式
        $this.addClass("am-on");
        //设置数值状态
        $(".am-eye-number").each(function() {
            $(this).text($(this).data("number"));
        });
    }

    //眼睛关闭事件
    function fnEyeClose() {
        //设置眼睛图标关闭样式
        $this.removeClass("am-on");
        //设置数值状态
        $(".am-eye-number").each(function() {
            if ($.trim($(this).text()) !== "****") {
                $(this).attr({
                    "data-number": $(this).text()
                });
            }
            $(this).text("****");
        });
    }
};

//fnScrollPanel
$.fn.fnScrollPanel = function(options) {
    if (!$(this).length) return;
    var defaults = {
        autoPlay: false, //自动播放
        speed: 3000, //自动播放间隔
        onChanged: function( /*index*/ ) {} //each call back
    };
    var opt = $.extend({}, defaults, options);

    return this.each(function() {
        var $this = $(this);
        var $thisInner;
        var $con = $this.find(".am-con");
        var $btnCon = $(".am-panel-btn[data-scroll='" + $this.attr("data-scroll") + "']");
        var $btn;
        var length = $con.length;
        var sIndex = 0;
        var touchLock = 1;
        var sLength = $.scrollX.length;
        init();

        function init() {

            //检测重复执行
            if ($this.hasClass($this.data("scroll"))) {
                //set new sLength
                sLength = $this.data("scroll").replace(/[^0-9]+/g, '');
                $.scrollX[sLength].destroy();
                $.scrollX[sLength] = null;
            }

            //设置scrollPanelInner和btn
            if (!$this.children(".scrollInner").length) {
                $this.addClass("scrollX" + $.scrollX.length).wrapInner("<div class='scrollInner' />");
                var btnHtml = "";
                for (var i = 0; i < length; i++) {
                    btnHtml += "<a></a>";
                }
                $btnCon.append(btnHtml);
            }
            $thisInner = $this.children(".scrollInner");
            $btn = $btnCon.children("a");

            //设置inner宽度和平分样式am-g-x
            $thisInner
                .attr({
                    "class": "scrollInner am-g-" + length
                })
                .css({
                    "width": length + "00%"
                });

            //定义滚动控件
            $.scrollX[sLength] = new IScroll(".scrollX" + sLength, {
                probeType: 3,
                scrollX: true,
                scrollY: false,
                momentum: false,
                snap: true,
                snapThreshold: 0.2
            });

            //初始设置
            $btn.eq(0).addClass("am-on").siblings().removeClass("am-on");
            $con.find("img").show();

            //绑定事件
            $.scrollX[sLength].on("beforeScrollStart", scrollStart);
            $.scrollX[sLength].on("scrollEnd", scrollEnd);
            $btn.off("touchend.scrollX").on("touchend.scrollX", function() {
                panelPlay($(this).index());
            });

            checkAutoPlay();
        }

        //滚动方法
        function panelPlay(i) {
            sIndex = i;
            $.scrollX[sLength].goToPage(sIndex, 0, 300);
            //每次滚动后重设置自动滚动间隔时间
            clearTimeout($.fnScrollPanelTimeOut);
            $.fnScrollPanelTimeOut = setTimeout(autoPlay, opt.speed);
        }

        //每次滚动开始事件
        function scrollStart() {
            //set lock when touch
            touchLock = 0;
            clearTimeout($.fnScrollPanelTimeOut);
        }

        //每次滚动完成事件
        function scrollEnd() {
            sIndex = $.scrollX[sLength].currentPage.pageX;
            //set btn current
            $btn.eq(sIndex).addClass("am-on").siblings().removeClass("am-on");
            //check lock
            if (!touchLock) {
                checkAutoPlay();
            }
        }

        //执行自动滚动
        function autoPlay() {
            if (sIndex === length - 1) {
                sIndex = 0;
            } else {
                sIndex++;
            }
            $.scrollX[sLength].goToPage(sIndex, 0, 300);
            clearTimeout($.fnScrollPanelTimeOut);
            $.fnScrollPanelTimeOut = setTimeout(autoPlay, opt.speed);
        }

        //检测自动滚动
        function checkAutoPlay() {
            touchLock = 1;
            if (opt.autoPlay) {
                //first play delay
                $.fnScrollPanelTimeOut = setTimeout(autoPlay, opt.speed);
            } else {
                clearTimeout($.fnScrollPanelTimeOut);
            }
        }
    });
};

//fnfootertips
$.fn.fnFooterTips = function() {
    if (!$(this).length) return;
    var $this = $(this);
    init();

    function init() {
        //has checking
        //bind resize
        //$.fn.fnFooterTips.reisze();
        // if ($.scrollY[0]) {
        //     $.scrollY[0].on("refresh", $.fn.fnFooterTips.reisze);
        // }
        //众安保险改为文档流排版
        $(".my-footer-tips").appendTo($.ambodyScroll);
    }
};

$.fn.fnFooterTips.reisze = function() {
    if ($.winResizeLock) {
        clearTimeout($.winResizeLock);
    }
    $.winResizeLock = setTimeout(function() {
        //排除处理以下部位
        var $this = $(".am-pos-fixb").not(".am-home-nav,.pro-btn-group,.am-offset-t32,.my-footer-tips").eq(0);
        //has checking""
        if (!$this.length) {
            return false;
        }
        //resize function
        var docH = $.scrollY[0].wrapperHeight;
        var $last = $.ambodyScroll.children("div").not(".am-pullUp").last();
        var lastPos = $last.offset().top + $last.height();
        if (docH > $.winH || (lastPos - $.amHeader.height() + $this.height() + $(".am-pos-fixb").height()) > $.winH) {
            $this.appendTo($.ambodyScroll);
        } else {
            $this.insertBefore($.ambody);
        }
        $.fn.fnBodyHeight();
    }, 200);
};

//fnBgImg
$.fn.fnBgImg = function() {
    if (!$(this).length) return;
    return this.each(function() {
        var $this = $(this);
        var $img = $this.find("img").eq(0);
        var src = $img.attr("src");
        init();

        //处理img标题图片为css背景图
        function init() {
            $this.css({
                "background-image": "url(" + src + ")"
            });
            $img.remove();
        }
    });
};

//fnBodyHeight
$.fn.fnBodyHeight = function() {
    var headerH = $.amHeader.height() || 0;
    var fixtopH = $("body>.am-pos-fixt").height() || 0;
    var noticeTopH = $("body>.am-notice-top").height() || 0;
    var noticeBottomH = $("body>.am-notice-bar").height() || 0;
    var fixbottomH = $("body>.am-pos-fixb:not(.my-footer-tips)").height() || 0;
    init();

    function init() {
        //设置ambody滚动区域的头尾
        $.ambody.css({
            bottom: noticeBottomH + fixbottomH,
            top: noticeTopH + headerH + fixtopH
        });
        //设置fixt容器的顶间距
        $("body>.am-pos-fixt").eq(0).css({
            top: noticeTopH + headerH
        });
    }
};

//fnBodyInner
$.fn.fnBodyInner = function() {
    //检测并添加inner结构
    if (!$(".am-body-inner").length) {
        $.ambody.wrapInner("<div class='am-body-inner' />");
    }
    //定义全局选择器
    $.ambodyInner = $("div.am-body-inner").eq(0);
};

//fnBodyPointer
$.fn.fnBodyPointer = function() {
    //处理页面底层功能，如点击穿透，整页模糊等
    if (!$.ambody.hasClass("am-on")) {
        $.ambody.addClass("am-on");
    } else {
        $.ambody.removeClass("am-on");
    }
};

//fnBtnSwitch
$.fn.fnBtnSwitch = function(options) {
    if (!$(this).length) return;
    var defaults = {
        onSwitch: function( /*id,state*/ ) {}
            //id当前点击控件的id
            //state是当前按键状态，true为打开，false为关闭
    };
    var opt = $.extend({}, defaults, options);
    return this.each(function() {
        var $this = $(this);
        var id = $(this).attr("id");
        var x, _x, y, _y;
        var touchSensitive = 80;
        var _state, state;
        init();

        function init() {
            //绑定事件
            $this.off("touchstart.switch").on("touchstart.switch", btnTouchStart);
        }

        //按钮按下事件
        function btnTouchStart(e) {
            //禁用页面滚动条
            $.scrollY[0].disable();
            //定义坐标
            $.settouch.init(e);
            _x = $.touchX;
            _y = $.touchY;
            //记录原始状态
            _state = $this.hasClass("am-on");
            //改变按钮样式，绑定事件
            $this.addClass("am-active");
            $this.off("touchend.switch").on("touchend.switch", btnTouchEnd);
            $this.off("touchmove.switch").on("touchmove.switch", btnTouchMove);
        }

        //按钮松开事件
        function btnTouchEnd() {
            //启用页面滚动条
            $.scrollY[0].enable();
            //切换状态
            if ($this.hasClass("am-on")) {
                $this.removeClass("am-on");
            } else {
                $this.addClass("am-on");
            }
            $this.removeClass("am-active");
            //当按键弹回后执行回调
            setTimeout(function() {
                opt.onSwitch(id, $this.hasClass("am-on"));
            }, $.globalAnimateSpeed);
        }

        //按钮移动事件
        function btnTouchMove(e) {
            //定义坐标
            $.settouch.init(e);
            x = $.touchX - _x;
            y = $.touchY - _y;
            //移动超出范围
            if (Math.abs(y) > touchSensitive || Math.abs(x) > touchSensitive) {
                $this.removeClass("am-active");
                state = $this.hasClass("am-on");
                $this.off("touchmove.switch").off("touchend.switch");
                //有改变开关状态
                if (_state !== state) {
                    opt.onSwitch(id, $this.hasClass("am-on"));
                }
                //启用页面滚动条
                $.scrollY[0].enable();
            }
            //移动在范围内
            else {
                //切换为关闭
                if ($this.hasClass("am-on") && x < touchSensitive / 4 * -1) {
                    $this.removeClass("am-on");
                    state = $this.hasClass("am-on");
                    $this.off("touchend.switch").on("touchend.switch", btnTouchMoveEnd);
                } else
                //切换到开启
                if (!$this.hasClass("am-on") && x > touchSensitive / 4) {
                    $this.addClass("am-on");
                    state = $this.hasClass("am-on");
                    $this.off("touchend.switch").on("touchend.switch", btnTouchMoveEnd);
                }
            }
        }

        //按键移动超出范围
        function btnTouchMoveEnd() {
            $this.removeClass("am-active");
            if (_state !== state) {
                opt.onSwitch(id, $this.hasClass("am-on"));
            }
        }
    });
};

//fnBtnTouch
$.fn.fnBtnTouch = function() {
    //定义按钮应用范围
    var $target = ".am-btn-active:not(.am-disable), a.am-btn:not(.am-disable):not(.am-loading), .am-popbtn:not(.am-disable), a.am-row:not(.am-disable), label.am-row:not(.am-disable), div.am-filter>a, div.am-sort>a, div.am-panel-btn>a, .am-header>a[class*='btn-'], .am-slidedown>.am-row>a.am-row-title";
    
    //绑定触发事件，仅在范围内生效
    $(document)
        .off("touchstart.btnTouch").on('touchstart.btnTouch', $target, function() {
            $(this).addClass("am-active");
        })
        .off("touchend.btnTouch").on("touchend.btnTouch", $target, function() {
            $(this).removeClass("am-active");
        })
        .off("touchmove.btnTouch").on("touchmove.btnTouch", $target, function() {
            //check touchmove && filter canmove btn(use for keyboard)
            if ($.touchMoved && !$(this).hasClass("canmove")) {
                $(this).removeClass("am-active");
            }
        });
};

//fnBtnVerifyCode
$.fn.fnBtnVerifyCode = function() {
    if (!$(this).length) return;
    var $this = $(this);
    var time = 60;
    var verifyTimeOut;
    init();

    function init() {
        clearTimeout($.varVerifyTimeOut);
        if (!$this.hasClass("am-disable") && time === 60) {
            $this.addClass("am-disable");
            countdown();
        }
    }

    //倒计时
    function countdown() {
        $this.text(time);
        if (time > 0) {
            time -= 1;
            verifyTimeOut = setTimeout(countdown, 1000);
        } else {
            fnClear();
        }
    }

    //终止倒计时
    function fnClear() {
        time = 60;
        $this.text("");
        $this.removeClass("am-disable");
        clearTimeout(verifyTimeOut);
    }

    //终止方法[外部]
    this.clear = function() {
        fnClear();
    }

    //链式调用
    return this;
};

//fnCheckDevice
$.fn.fnCheckDevice = function() {
    init();

    function init() {
        //设置是否禁用动画
        if (($.config.system.android && $.config.version < 6.0) || ($.config.system.ios && $.config.version < 8.0)) {
            $.globalEffect = 0;
            $.htmlBody.addClass("am-effect-off");
        } else {
            $.globalEffect = 1;
            $.htmlBody.removeClass("am-effect-off");
        }
        //设置全局js动画时长
        $.globalAnimateSpeed = $.globalEffect ? 300 : 0;

        //设置浏览器标记样式
        if ($.config.system.ios) {
            $.htmlBody.addClass("ios");
        }
        if ($.config.system.win) {
            $.htmlBody.addClass("win");
        }
        if ($.config.system.mac) {
            $.htmlBody.addClass("mac");
        }
        if ($.config.system.android) {
            $.htmlBody.addClass("android");
        }
        if ($.config.browser.chrome) {
            $.htmlBody.addClass("chrome");
        }
        if ($.config.browser.safari) {
            $.htmlBody.addClass("safari");
        }
        if ($.config.browser.msie) {
            $.htmlBody.addClass("msie");
        }
        if ($.config.browser.ipad) {
            $.htmlBody.addClass("ipad");
        }

        //检测当前引用jQuery || Zepto
        if (typeof(jQuery) !== "undefined") {
            $.isjq = true;
        } else {
            $.isjq = false;
        }

        //轮训检测窗口宽高
        checkReady();

        //check orientation
        fnOrientationchange();
        $(window)
            .off("orientationchange")
            .on("orientationchange", fnOrientationchange);
    }

    //检测设置旋转
    function fnOrientationchange() {
        clearTimeout($.orientationTimeout);
        $.orientationTimeout = setTimeout(function() {
            $.winW = $(window).width();
            $.winH = $(window).height();
            if (window.orientation === 90 || window.orientation === -90) {
                $.htmlBody.addClass("am-orientation-on");
            } else if (window.orientation === 0 || window.orientation === 180) {
                $.htmlBody.removeClass("am-orientation-on");
            }
            for (var i = 0; i < $.scrollY.length; i++) {
                $.scrollY[i].refresh();
            }
        }, 200);
    }

    //检测窗口尺寸设置
    function checkReady() {
        if (!($(window).height() > 1)) {
            setTimeout(checkReady, 1000 / 60);
        } else {
            $.winW = $(window).width();
            $.winH = $(window).height();
            //set font size
            checkFontSize();
        }
    }

    //检测当前默认字号
    function checkFontSize() {
        $.fontSize = parseInt($("html").css("font-size"));
    }
};

//fnChecked
$.fn.fnChecked = function(options) {
    if (!$(this).length) return;
    var defaults = {
        onChecked: function( /*name,state*/ ) {}
            //name当前表单控件的data-name，同组需要定义相同的data-name值
            //state是当前按键状态，1为打开，0为关闭
    };
    var opt = $.extend({}, defaults, options);
    return this.each(function() {
        var $this = $(this);
        var state = [];
        var type, name, length;
        init();

        function init() {
            //绑定事件
            $this.off("touchend.check").on("touchend.check", btnTouchend);
        }

        //按钮点击事件
        function btnTouchend() {
            //检测点击移动 & 当前禁用
            if ($.touchMoved || $this.hasClass("am-disable")) return;
            //检测radio或checkbox
            if ($this.data("type") === "radio") {
                type = 1; //radio
            } else {
                type = 2; //checkbox
            }
            //设置当前点击组name
            name = $this.data("name");
            //设置当前点击组长度
            length = $("label[data-name='" + name + "']").length;
            //type radio
            if (type === 1 && !$this.find("span.am-icon-radio").hasClass("am-on")) {
                $("label[data-name='" + name + "']").find("span.am-icon-radio").removeClass("am-on");
                $this.find("span.am-icon-radio").addClass("am-on");
                //state set
                state = [$this.index()];
            }
            //type checkbox
            else if (type === 2) {
                if ($this.find("span.am-icon-checkbox").hasClass("am-on")) {
                    $this.find("span.am-icon-checkbox").removeClass("am-on");
                } else {
                    $this.find("span.am-icon-checkbox").addClass("am-on");
                }
                //state array set
                for (var i = 0; i < length; i++) {
                    var tempType = $("label[data-name='" + name + "']").eq(i).find("span.am-on").length || 0;
                    state[i] = tempType;
                }
            }
            //callback
            opt.onChecked(name, state);
        }
    });
};

//fnDropDown
$.fn.fnDropDown = function(options) {
    if (!$(this).length) return;
    var defaults = {
        only: true, //only one line at one time
        onDropdown: function( /*id,index,state*/ ) {}
            //id当前点击位置所在组的id
            //index当前点击位置所在本列表的index
            //state当前点击位置的状态，1为打开，0为关闭
    };
    var opt = $.extend({}, defaults, options);
    return this.each(function() {
        var $this = $(this);
        var $close = $this.parent().find("a.am-close");
        var $con = $this.next("div.am-dropdown-con");
        var $thisparent = $this.parent("div.am-row");
        var index = $thisparent.index();
        var id = $thisparent.parent("div.am-dropdown").attr("id");
        var state;
        init();

        function init() {
            if ($this.parent("div.am-on").length) {
                index = $this.parent().index();
                state = 1;
                //callback
                setTimeout(fnDropEnd, $.globalAnimateSpeed);
            }
            //has dropdown checking
            if ($con.length) {
                //btn click
                $this.add($close).off("touchend.dropdown").on("touchend.dropdown", function() {
                    btnClick();
                });
            }
        }

        //下拉点击事件
        function btnClick() {
            if ($.touchMoved) return;
            if (!$thisparent.hasClass("am-on")) {
                //opt.only checking
                if (opt.only) {
                    $thisparent.siblings().removeClass("am-on");
                }
                $thisparent.addClass("am-on");
                state = 1;
            } else {
                $thisparent.removeClass("am-on");
                state = 0;
            }
            //callback
            setTimeout(fnDropEnd, $.globalAnimateSpeed);
        }

        function fnDropEnd() {
            //刷新当前pageY滚动条
            $.scrollY[$.xIndex].refresh();
            opt.onDropdown(id, index, state);
        }
    });
};

//fnGetBoxSize
$.fn.fnGetBoxSize = function() {
    var $this = $(this);
    var w = $this.width();
    var h = $this.height();
    init();

    function init() {
        $this.addClass("am-get-box-size");
        $this.attr({
            "data-width": w,
            "data-height": h
        });
        $this.removeClass("am-get-box-size");
    }
};

//fnIndexBar
$.fn.fnIndexBar = function(options) {
    if (!$(this).length) return;
    var defaults = {
        indexData: false
    };
    var opt = $.extend({}, defaults, options);
    var $this = $(this);
    var $bar = $this.find("div.am-index");
    var $slide = $(".am-indexBar-slide");
    var indexH = $bar.eq(0).height();
    var $index = $("#am-index").eq(0);
    var length = $bar.length;
    var indexTop = new Array(length);
    var current = 0;
    var offset = 3; // 3为了消除遮挡上边框造成的偏移
    var y, slideT, slideH;
    var defaultTop = $.amHeader.height() || 0; //无header时上边框为0
    init();

    function init() {
        fnRefresh();

        //set scroll function
        $.scrollY[0].off("scroll", fnSetScroll);
        $.scrollY[0].on("scroll", fnSetScroll);

        //check add $slide
        if (opt.indexData && !$slide.length) {
            $.ambody.addClass("page-noscroll");
            //set html
            var slideHtml = "<div class='am-indexBar-slide'>";
            for (var i = 0; i < opt.indexData.length; i++) {
                slideHtml += "<span>" + opt.indexData[i].toUpperCase() + "</span>";
            }
            slideHtml += "</div>";
            //add dom
            $.ambodyInner.append(slideHtml);
            //set event
            $slide = $(".am-indexBar-slide");
            $slide.on("touchmove", fnSlideMove);
            $slide.children("span").on("touchend", fnSlideTouch);
            slideT = $slide.offset().top;
            slideH = $slide.height();
        }
    }

    function fnRefresh() {
        $bar = $this.find("div.am-index");
        length = $bar.length;
        //set each indexTop
        for (var i = 0; i < length; i++) {
            //am-body scroll need add value sTop
            indexTop[i] = $bar.eq(i).offset().top + $.sTop * -1; 
        }
    }

    function fnSetScroll(c) {
        //set header container
        if (indexTop[0] > $.sTop * -1 + defaultTop && $index.length) {
            $index.remove();
            $index = false;
        } else if (indexTop[0] - offset < $.sTop * -1 + defaultTop && !$index.length) {
            $.htmlBody.append("<div id='am-index' class='am-index' style='top:" + defaultTop + "px'></div>");
            $index = $("#am-index").eq(0);
        }
        //判断是否指定current值，只在scroll事件中
        if (c === undefined) {
            //current checking
            for (var i = 0; i < length; i++) {
                if (indexTop[i] < $.sTop * -1 + defaultTop) {
                    current = i;
                    $index.html($bar.eq(current).html());
                }
            }
        }
        //change animate
        if (indexTop[current + 1] < $.sTop * -1 + defaultTop + indexH) {
            var y = indexTop[current + 1] - $.sTop * -1 - defaultTop - indexH;
            $index.find("span").css({
                "-webkit-transform": "translate3d(0," + y + "px,0)",
                "-moz-transform": "translate3d(0," + y + "px,0)",
                "transform": "translate3d(0," + y + "px,0)"
            });
        }
    }
    //index条点击事件
    function fnSlideTouch() {
        if (!$.touchMoved) {
            current = $(this).index();
            fnCheckScrollEnd();
        }
    }
    //index条move事件
    function fnSlideMove(e) {
        //定义坐标
        $.settouch.init(e);
        y = $.touchY - slideT;
        current = Math.round(y / (slideH / length) - 0.5);
        current < 0 ? current = 0 : true;
        current > length - 1 ? current = length - 1 : true;
        fnCheckScrollEnd();

    }
    //检查当前index下数据是否满足一页，设置滚动条y轴
    function fnCheckScrollEnd() {
        var t = -1 * indexTop[current] + $.amHeader.height();
        if (t < $.scrollY[0].maxScrollY) {
            t = $.scrollY[0].maxScrollY;
        } else {
            if ($index.length) {
                $index.html($bar.eq(current).html());
            }
        }
        $.scrollY[0].scrollTo(0, t);
        fnSetScroll(current);
    }

    //link order
    this.refresh = function() {
        fnRefresh();
    }
    return this;
};

//fnInput
$.fn.fnInput = function(options) {
    if (!$(this).length) return;
    var defaults = {
        onClear: function() {}
    };
    var opt = $.extend({}, defaults, options);
    return this.each(function() {
        var $thisInput = $(this);
        var $btnClear = $(this).prev(".am-input-clear");
        var $btnPwd = $(this).prev(".am-input-pwd").length ? $(this).prev(".am-input-pwd") : $btnClear.prev(".am-input-pwd");
        var required = $(this).attr("required") ? true : false;
        var fName = required ? $thisInput.parents("[data-form*='form']").data("form") : "form";
        var $formBtn = required ? $("[data-form='" + fName + "-btn']") : false;
        var $formInput = required ? $("[data-form='" + fName + "']").find("input[required]") : false;
        init();

        function init() {
            fnSetBtnClear();
            fnCheckFormBtn();

            //check has btnclear
            if ($btnClear.length) {
                $btnClear
                    .off("touchend.clear")
                    .on("touchend.clear", function() {
                        //touchmoved checking
                        if ($.touchMoved) {
                            return false;
                        }
                        $btnClear.hide();
                        $thisInput.val("");
                        fnCheckFormBtn();
                        opt.onClear();
                    });
                $thisInput
                    .off("input.clear")
                    .on("input.clear", function() {
                        fnSetBtnClear();
                        fnCheckFormBtn();
                        if ($thisInput.val() === "") {
                            opt.onClear();
                        }
                    })
                    .off("focus.clear blur.clear")
                    .on("focus.clear", fnSetBtnClear)
                    .on("blur.clear", fnSetBtnClear);
            }

            //check has btnpwd
            if ($btnPwd.length) {
                $btnPwd
                    .show()
                    .off("touchend.pwd")
                    .on("touchend.pwd", function() {
                        //touchmoved checking
                        if ($.touchMoved) {
                            return false;
                        }
                        if (!$(this).parent().hasClass("am-on")) {
                            $(this).parent().addClass("am-on");
                            $thisInput.attr({
                                "type": "text"
                            });
                        } else {
                            $(this).parent().removeClass("am-on");
                            $thisInput.attr({
                                "type": "password"
                            });
                        }
                    });
            }
        }

        function fnSetBtnClear() {
            setTimeout(function() {
                if ($thisInput.val() && $thisInput.is(":focus")) {
                    $btnClear.show();
                } else {
                    $btnClear.hide();
                }
            });
        }

        function fnCheckFormBtn() {
            var pass = true;
            if ($formBtn) {
                for (var i = 0; i < $formInput.length; i++) {
                    if ($formInput.eq(i).val() === "") {
                        pass = false;
                    }
                }
                pass ? $formBtn.removeClass("am-disable") : $formBtn.addClass("am-disable");
            }
        }
    });
};

//fnInputBlur
$.fn.fnInputBlur = function() {
    var $slideRulerInner = $(".am-slideRuler");
    init();

    function init() {
        //for input blur
        $(document).off("touchend.inputBlur");
        $(document).on("touchend.inputBlur", function(e) {
            if ((e.target.tagName !== "INPUT")
             && ($("svg").has(e.target).length === 0)
             && (e.target.className.indexOf("am-input-clear") < 0)
             && ($slideRulerInner.has(e.target).length === 0)) {
                $(".am-input").blur();
            }
        });
    }
};

//fnKeyBoard
$.fn.fnKeyBoard = function(options) {
    var defaults = {
        id: "", //对应输入框id
        type: 0, //0数字，1字母，2符号
        min: 6, //最小长度
        max: 20, //最大长度
        numberOnly: true, //仅可使用数字键盘
        letterUp: false, //字母键盘默认为大写
        keyRandom: false, //按键随机排列
        filter: [43, 45, 92, 47, 91, 93, 123, 125, 44, 46, 8364, 163, 165, 32], //过渡字符,ascii码
        onChanged: function(val, lastkey) {}, //回调-每次改变数值
        onCancel: function() {}, //回调-取消
        onDone: function(val) {}, //回调-完成
        onOffsetMin: function(min) {}, //回调-完成时，长度小于最小值
        onOffsetMax: function(max) {}, //回调-完成时，长度大于最大值
        onFilter: function() {} //回调-遇到过滤字符时
    };
    var opt = $.extend({}, defaults, options);
    var $keyboard = $(".am-keyboard-con>.am-keyboard"); //键盘容器
    var $keyboardCon = $keyboard.parent(".am-keyboard-con"); //键盘外层容器
    var $keyboardCtrl = $keyboardCon.children(".ctrl"); //隐藏控制容器
    var $keyboardCtrlBtn; //隐藏控制容器中的按键，用于随机排列按键
    var $keyboardL = $keyboard.filter(".letter"); //定义字母键盘
    var $keyboardN = $keyboard.filter(".number"); //定义数字键盘
    var $keyboardS = $keyboard.filter(".symbol"); //定义符号键盘
    var $keyBtn; //定义普通按键
    var $keyFnBtn; //定义功能按键
    var $keyBtnGroup; //定义当前显示键盘普通按键
    var $input = $("#" + opt.id); //安全键盘输入框
    var $inputAll = $(".am-keyboard-input");
    var $btnClear = $input.prev(".am-input-clear"); //输入框清除按键
    var $btnPwd = $btnClear.prev(".am-input-pwd"); //密码显示按键
    var fnbtnSelector = ".btnFnLetter,.btnFnSymbol,.btnFnSpace,.btnFnShift,.btnFnDelete,.btnFnCancel,.btnFnDone,.btnFnNull,.btnFnPoint";
    var inputVal = $input.attr("data-value") !== undefined ? String($input.attr("data-value")) : ""; //设置输入框当前值，必须为string
    var inputValLast = ""; //输入框最后一次输入值
    var deleteInterval; //删除长按间隔轮训
    var deleteTimeout; //删除长按后，开始连续删除的间隔
    var keyMove_x, keyMove_y; //普通按键手指滑动坐标
    var keyMoveIn = 0; //是否开始按键滑动
    var eyeOpen = $btnPwd.parent(".am-on").length; //密码显示状态
    var delayTime = 1; //键盘延迟弹出时间
    var arrayAfter = [];
    var arrayBefore = [];
    init();

    function init() {
        //重复点击输入框处理
        if ($input.hasClass("am-on")) {
            return false;
        }

        //判断键盘是否已存在
        if ($(".am-keyboard-con").length) {
            //清除已展开键盘的眼睛与删除按键
            $inputAll.prev(".am-input-clear").hide().prev(".am-input-pwd").hide();
        }

        //初始化判断numberonly
        if (opt.numberOnly) {
            $keyboardN.children(".am-g").eq(1).children(".btnFnPoint").addClass("btnFnNull");
        }

        //初始化判断letterup
        if (opt.letterUp) {
            $keyboardL.addClass("up");
        }

        //初始化按键随机排列
        fnKeyRandom(opt.type);

        //初始化默认键盘类型并显示
        $keyboard.removeClass("am-on").eq(opt.type).addClass("am-on");

        //上拉键盘动画后延迟200ms设置按键坐标
        setTimeout(function() {
            fnSetKeyPos(opt.type);
        }, $.globalAnimateSpeed + 200);

        //定义按键及功能键选择器
        $keyFnBtn = $keyboard.find(fnbtnSelector);
        $keyBtn = $keyboard.find(".am-btn").not(fnbtnSelector);

        //绑定事件
        $(document)
            .off("touchend.keyboard")
            .on("touchend.keyboard", fnKBClose);
        $keyFnBtn
            .off("touchend.keyboard touchstart.keyboard touchmove.keyboard")
            .on("touchstart.keyboard", fnKeyFnDown)
            .on("touchend.keyboard", fnKeyFnUp)
            .on("touchmove.keyboard", fnKeyFnMove);
        $keyBtn
            .off("touchend.keyboard touchstart.keyboard touchmove.keyboard touchmove.btnTouch")
            .on("touchstart.keyboard", fnKeyDown)
            .on("touchend.keyboard", fnKeyUp)
            .on("touchmove.keyboard", fnKeyMove);
        $btnPwd
            .off("touchend.keyboard")
            .on("touchend.keyboard", fnBtnPwd);
        $btnClear
            .off("touchend.keyboard")
            .on("touchend.keyboard", fnBtnClear);

        //keyboard show
        setTimeout(function() {
            fnKBSwitch(1);
            fnCheckBtnState();
            $btnPwd.show();
        }, delayTime);
    }

    //眼睛按键状态切换
    function fnBtnPwd() {
        if (!$.touchMoved) {
            if ($(this).parent().hasClass("am-on")) {
                $(this).parent().removeClass("am-on");
                eyeOpen = 0;
            } else {
                $(this).parent().addClass("am-on");
                eyeOpen = 1;
            }
            fnCheckBtnPwd();
        }
    }

    //眼睛按键功能
    function fnCheckBtnPwd() {
        $input.attr({
            "data-value": inputVal
        });
        if (eyeOpen === 0) {
            var tempVal = "";
            for (var i = 0; i < inputVal.length; i++) {
                tempVal += "●";
            }
            $input.text(tempVal);
        } else {
            $input.text($input.attr("data-value"));
        }
    }

    //清除按键事件
    function fnBtnClear() {
        if (!$.touchMoved) {
            fnValueClear();
        }
    }

    //清除功能
    function fnValueClear() {
        inputVal = "";
        $input.text("");
        $input.attr({
            "data-value": ""
        });
        fnCheckBtnClearDone();
    }

    //检查清除&完成按键状态
    function fnCheckBtnClearDone() {
        if (inputVal !== "" && $input.hasClass("am-on")) {
            $btnClear.show();
            $keyboard.find(".btnFnDone").addClass("am-on");
        } else {
            $btnClear.hide();
            $keyboard.find(".btnFnDone").removeClass("am-on");
        }
    }

    //检查各种按键状态
    function fnCheckBtnState() {
        fnCheckBtnPwd();
        fnCheckBtnClearDone();
    }

    //检查过滤字符
    function fnCheckFilterKey() {
        //包含需要过滤字符
        if (opt.filter.indexOf(inputValLast) > -1) {
            if (inputValLast === 32) {
                inputValLast = "空格" //特殊处理"空格"
            } else {
                inputValLast = String.fromCharCode(inputValLast); //其它过渡字符
            }
            opt.onFilter(inputValLast); //过渡后回调
            inputValLast = ""; //过渡后清除变量
        }
        //不包含需要过滤字符
        else {
            inputValLast = String.fromCharCode(inputValLast);
        }
    }

    //普通按键down事件
    function fnKeyDown() {
        if ($.scrollY[0]) {
            $.scrollY[0].disable();
        }
        $keyBtn.removeClass("am-active");
    }

    //普通按键up事件
    function fnKeyUp() {
        //reset scroll
        if ($.scrollY[0]) {
            $.scrollY[0].enable();
        }

        //直接点击，定义inputvallast值
        if (!$.touchMoved) {
            inputValLast = $(this).data("ascii");
        }

        //检查过滤字符
        fnCheckFilterKey();

        //处理大写字母转换
        if ($(this).parents(".am-keyboard").hasClass("up")) {
            inputValLast = inputValLast.toUpperCase();
        }

        //设置当前输入框最终结果
        inputVal += inputValLast.replace(/(^\s*)|(\s*$)/g, "");

        //超出max时的处理
        if (inputVal.length > opt.max) {
            inputVal = inputVal.substring(0, opt.max);
            opt.onOffsetMax(opt.max);
        }
        //未超出max时的处理
        else {
            $input.text(inputVal);
            opt.onChanged(inputVal, inputValLast);
        }

        //按下移动后，移除所有按键active样式
        if ($.touchMoved) {
            $keyBtnGroup.removeClass("am-active");
        }

        fnCheckBtnState();
    }

    //普通按键move事件
    function fnKeyMove(e) {
        //获取手指滑动坐标
        $.settouch.init(e);
        keyMove_x = $.touchX;
        keyMove_y = $.touchY;
        //匹配当前按键
        $keyBtnGroup.each(function() {
            if (keyMove_x > $(this).data("left") && keyMove_x < $(this).data("right") && keyMove_y > $(this).data("top") && keyMove_y < $(this).data("bottom")) {
                keyMoveIn = 1;
                //检查重复执行
                if (inputValLast !== $(this).data("ascii")) {
                    $keyBtnGroup.removeClass("am-active");
                    $(this).addClass("am-active");
                    inputValLast = $(this).data("ascii");
                }
                return;
            }
        });
    }

    //功能按键down事件
    function fnKeyFnDown() {
        if ($.scrollY[0]) {
            $.scrollY[0].disable();
        }
        //删除按键长按事件
        if ($(this).hasClass("btnFnDelete")) {
            valDelete();
            deleteTimeout = setTimeout(function() {
                deleteInterval = setInterval(valDelete, 150);
            }, 750);

        }

        $keyBtnGroup.removeClass("am-active");

        function valDelete() {
            inputVal = inputVal.substring(0, inputVal.length - 1);
            $input.text(inputVal);
            fnCheckBtnState();
        }
    }

    //功能按键up事件
    function fnKeyFnUp() {
        //reset scroll
        $.scrollY[0].enable();
        //判断触摸移动
        if ($.touchMoved) {
            return false;
        }
        //切换至字母键盘
        if ($(this).hasClass("btnFnLetter")) {
            $keyboardL.addClass("am-on").siblings().removeClass("am-on");
            fnKeyRandom(1);
            fnSetKeyPos(1);
        } else
        //切换至符号键盘
        if ($(this).hasClass("btnFnSymbol")) {
            $keyboardS.addClass("am-on").siblings().removeClass("am-on");
            fnKeyRandom(2);
            fnSetKeyPos(2);
        } else
        //完成按键
        if ($(this).hasClass("btnFnDone") && $(this).hasClass("am-on")) {
            if (inputVal.length >= opt.min) {
                fnKBSwitch(0);
                opt.onDone(inputVal);
                fnValueClear();
            } else {
                opt.onOffsetMin(opt.min);
            }
        } else
        //取消按键
        if ($(this).hasClass("btnFnCancel")) {
            fnKBSwitch(0);
            opt.onCancel();
        } else
        //空格按键
        if ($(this).hasClass("btnFnSpace")) {
            inputValLast = $(this).data("ascii");
            fnCheckFilterKey();
            opt.onChanged(inputVal, inputValLast);
        } else
        //Shift按键
        if ($(this).hasClass("btnFnShift")) {
            if ($keyboardL.hasClass("up")) {
                $keyboardL.removeClass("up");
            } else {
                $keyboardL.addClass("up");
            }
        } else
        //删除按键
        if ($(this).hasClass("btnFnDelete")) {
            clearInterval(deleteInterval);
            clearTimeout(deleteTimeout);
            opt.onChanged(inputVal, "delete");
        }

        fnCheckBtnState();
    }

    //功能按键move事件
    function fnKeyFnMove() {
        //check deleting touchmove
        if ($.touchMoved && $(this).hasClass("btnFnDelete")) {
            clearInterval(deleteInterval);
            clearTimeout(deleteTimeout);
        }
    }

    //按键随机排版处理
    function fnKeyRandom(type) {
        if (opt.keyRandom) {
            //判断数字&符号键盘处理方式
            var randomType = 1;
            if (type === 2) {
                randomType = 2;
            }

            for (var i = 1; i < randomType + 1; i++) {


                //定义普通按键选择器
                $keyBtnGroup = $keyboard.eq(type).children(".am-g").eq(i).children(".am-btn").not(fnbtnSelector);
                $keyboardCtrl.empty();
                $keyBtnGroup.clone().prependTo($keyboardCtrl);

                getKeyIndex();
                setKeyIndex();

                //重新绑定普通按键各类事件
                $keyBtn = $keyboard.eq(type).children(".am-g").eq(i).children(".am-btn").not(fnbtnSelector);
                $keyBtn
                    .off("touchend.keyboard touchstart.keyboard touchmove.keyboard touchmove.btnTouch")
                    .on("touchstart.keyboard", fnKeyDown)
                    .on("touchend.keyboard", fnKeyUp)
                    .on("touchmove.keyboard", fnKeyMove);
            }
        }
    }

    //获取按键位置
    function getKeyIndex() {
        arrayAfter = [];
        for (var i = 0; i < $keyBtnGroup.length; i++) {
            arrayAfter.push(i);
        }
    }

    //设置按键位置
    function setKeyIndex() {
        arrayBefore = arrayAfter.concat().sort(randomsort);
        $keyboardCtrlBtn = $keyboardCtrl.children(".am-btn");
        for (var i = 0; i < $keyBtnGroup.length; i++) {
            $keyBtnGroup.eq(i).replaceWith($keyboardCtrlBtn.eq(arrayBefore[i]));
        }
    }

    //排列数组算法
    function randomsort(a, b) {
        return Math.random() > .5 ? -1 : 1;
    }

    //设置普通按键定位范围
    function fnSetKeyPos(type) {
        //定义普通按键选择器
        $keyBtnGroup = $keyboard.eq(type).find(".am-btn").not(fnbtnSelector);

        $keyBtnGroup.each(function() {
            var l = Math.round($(this).offset().left);
            var t = Math.round($(this).offset().top);
            var r = Math.round(l + $(this).width());
            var b = Math.round(t + $(this).height());
            $(this).data("top", t).data("right", r).data("bottom", b).data("left", l);
        });
    }

    //键盘弹出&收起
    function fnKBSwitch(state) {
        if (state === 1) {
            //模拟IOS键盘，延迟弹出
            $inputAll.removeClass("am-on");
            $input.add($keyboardCon).addClass("am-on");
        } else {
            $input.add($keyboardCon).removeClass("am-on am-show");
            $btnPwd.hide();
            $btnClear.hide();
        }
    }

    //键盘开启后页面空白处点击关闭
    function fnKBClose(e) {
        if ((e.target.className.indexOf("am-keyboard-input") === -1) &&
            (e.target.className.indexOf("am-input-pwd") === -1) &&
            (e.target.className.indexOf("am-input-clear") === -1) &&
            (e.target.parentNode.className.indexOf("am-keyboard") === -1) &&
            (e.target.parentNode.parentNode.className.indexOf("am-keyboard") === -1) &&
            (e.target.parentNode.parentNode.parentNode.className.indexOf("am-keyboard") === -1)
        ) {
            fnKBSwitch(0);
        }
    }
};
$.fn.fnKeyBoard.ready = function() {
    if (!$(".am-keyboard-input").length) return;
    var dom = "<div class='am-keyboard-con'><div class='am-keyboard number'><div class='am-g'><h6><span class='am-icon-security2 am-icon-36'></span>鲸钱包安全键盘</h6><a class='am-btn btnFnCancel nozoom'><span>收起</span></a></div><div class='am-g'><a class='am-btn btn-n1 canmove nozoom' data-ascii='49'>1</a><a class='am-btn btn-n2 canmove nozoom' data-ascii='50'>2</a><a class='am-btn btn-n3 canmove nozoom' data-ascii='51'>3</a><a class='am-btn btn-n4 canmove nozoom' data-ascii='52'>4</a><a class='am-btn btn-n5 canmove nozoom' data-ascii='53'>5</a><a class='am-btn btn-n6 canmove nozoom' data-ascii='54'>6</a><a class='am-btn btn-n7 canmove nozoom' data-ascii='55'>7</a><a class='am-btn btn-n8 canmove nozoom' data-ascii='56'>8</a><a class='am-btn btn-n9 canmove nozoom' data-ascii='57'>9</a><a class='am-btn btnFnPoint canmove nozoom' data-ascii='46'>.</a><a class='am-btn btn-n0 canmove nozoom' data-ascii='48'>0</a><a class='am-btn nozoom am-btnLight btnFnDelete'></a></div></div><div class='am-keyboard letter'><div class='am-g'><h6><span class='am-icon-security2 am-icon-36'></span>鲸钱包安全键盘</h6><a class='am-btn btnFnCancel nozoom'><span>收起</span></a></div><div class='am-g'><a class='am-btn canmove' data-ascii='113'><span>q</span></a><a class='am-btn canmove' data-ascii='119'><span>w</span></a><a class='am-btn canmove' data-ascii='101'><span>e</span></a><a class='am-btn canmove' data-ascii='114'><span>r</span></a><a class='am-btn canmove' data-ascii='116'><span>t</span></a><a class='am-btn canmove' data-ascii='121'><span>y</span></a><a class='am-btn canmove' data-ascii='117'><span>u</span></a><a class='am-btn canmove' data-ascii='105'><span>i</span></a><a class='am-btn canmove' data-ascii='111'><span>o</span></a><a class='am-btn canmove' data-ascii='112'><span>p</span></a><a class='am-btn canmove' data-ascii='97'><span>a</span></a><a class='am-btn canmove' data-ascii='115'><span>s</span></a><a class='am-btn canmove' data-ascii='100'><span>d</span></a><a class='am-btn canmove' data-ascii='102'><span>f</span></a><a class='am-btn canmove' data-ascii='103'><span>g</span></a><a class='am-btn canmove' data-ascii='104'><span>h</span></a><a class='am-btn canmove' data-ascii='106'><span>j</span></a><a class='am-btn canmove' data-ascii='107'><span>k</span></a><a class='am-btn canmove' data-ascii='108'><span>l</span></a><a class='am-btn am-btnLight btnFnShift nozoom'><span></span></a><a class='am-btn canmove' data-ascii='122'><span>z</span></a><a class='am-btn canmove' data-ascii='120'><span>x</span></a><a class='am-btn canmove' data-ascii='99'><span>c</span></a><a class='am-btn canmove' data-ascii='118'><span>v</span></a><a class='am-btn canmove' data-ascii='98'><span>b</span></a><a class='am-btn canmove' data-ascii='110'><span>n</span></a><a class='am-btn canmove' data-ascii='109'><span>m</span></a><a class='am-btn am-btnLight btnFnDelete nozoom'><span></span></a><a class='am-btn am-btnLight btnFnSymbol nozoom'><span>123</span></a><a class='am-btn nozoom btnFnSpace' data-ascii='32'><span>空格</span></a><a class='am-btn am-btnLight btnFnDone nozoom'><span>完成</span></a></div></div><div class='am-keyboard symbol'><div class='am-g'><h6><span class='am-icon-security2 am-icon-36'></span>鲸钱包安全键盘</h6><a class='am-btn btnFnCancel nozoom'><span>收起</span></a></div><div class='am-g'><a class='am-btn canmove' data-ascii='49'><span>1</span></a><a class='am-btn canmove' data-ascii='50'><span>2</span></a><a class='am-btn canmove' data-ascii='51'><span>3</span></a><a class='am-btn canmove' data-ascii='52'><span>4</span></a><a class='am-btn canmove' data-ascii='53'><span>5</span></a><a class='am-btn canmove' data-ascii='54'><span>6</span></a><a class='am-btn canmove' data-ascii='55'><span>7</span></a><a class='am-btn canmove' data-ascii='56'><span>8</span></a><a class='am-btn canmove' data-ascii='57'><span>9</span></a><a class='am-btn canmove' data-ascii='48'><span>0</span></a></div><div class='am-g'><a class='am-btn canmove' data-ascii='96'><span>`</span></a><a class='am-btn canmove' data-ascii='33'><span>!</span></a><a class='am-btn canmove' data-ascii='64'><span>@</span></a><a class='am-btn canmove' data-ascii='35'><span>#</span></a><a class='am-btn canmove' data-ascii='36'><span>$</span></a><a class='am-btn canmove' data-ascii='37'><span>%</span></a><a class='am-btn canmove' data-ascii='94'><span>^</span></a><a class='am-btn canmove' data-ascii='38'><span>&</span></a><a class='am-btn canmove' data-ascii='42'><span>*</span></a><a class='am-btn canmove' data-ascii='43'><span>+</span></a><a class='am-btn canmove' data-ascii='45'><span>-</span></a><a class='am-btn canmove' data-ascii='92'><span>&#92;</span></a><a class='am-btn canmove' data-ascii='47'><span>/</span></a><a class='am-btn canmove' data-ascii='91'><span>[</span></a><a class='am-btn canmove' data-ascii='93'><span>]</span></a><a class='am-btn canmove' data-ascii='123'><span>{</span></a><a class='am-btn canmove' data-ascii='125'><span>}</span></a><a class='am-btn am-btnLight btnFnDelete nozoom'><span></span></a><a class='am-btn am-btnLight btnFnLetter nozoom'><span>ABC</span></a><a class='am-btn canmove' data-ascii='44'><span>,</span></a><a class='am-btn canmove' data-ascii='46'><span>.</span></a><a class='am-btn canmove' data-ascii='8364'><span>€</span></a><a class='am-btn canmove' data-ascii='163'><span>£</span></a><a class='am-btn canmove' data-ascii='165'><span>¥</span></a><a class='am-btn am-btnLight btnFnDone nozoom'><span>完成</span></a></div></div><div class='ctrl'></div><div class='imgload'></div></div>";
    var preloadImg = "<img class='active' src='images/keyboard-active.png'><img class='active' src='images/keyboard-shift-black.png'><img class='active' src='images/keyboard-delete-black.png'>";
    init();

    function init() {
        //判断键盘是否已存在
        if (!$(".am-keyboard-con").length) {
            //加载键盘html代码
            $.htmlBody.append(dom);
            //初始化预加载素材图片
            $(".am-keyboard-con>.imgload").append(preloadImg);
            //初始化键盘高度
            $.winW >= 768 ? $(".am-keyboard-con").height($.winW / 2.5) : $(".am-keyboard-con").height($.winW / 1.46);
        }
    }
};

//fnListDrag
$.fn.fnListDrag = function(options) {
    if (!$(this).length) return;
    var defaults = {
        controlHtml: "<div class='control'><a class='delete'><span class='am-icon-delete-w am-icon-36'></span></a></div>",
        selectHtml: "<label class='am-row' data-type='checkbox' data-name='listDragLabel'><span class='am-icon-checkbox'></span></label>",
        headerHtml: "<div class='listDragHead'><a class='am-btn select'>全选</a><a class='am-btn cancel'>取消</a></div>",
        deleteBtn: ".am-header>.btn-delete",
        onDraged: function() {}, //任何一项向左滑动开启后
        onReturn: function() {}, //任何一项关闭后
        onNoSelect: function() {}, //零项删除后
        onDelete: function(index) {} //一项或多项删除后
    };
    var opt = $.extend({}, defaults, options);
    return this.each(function() {
        var $list = $(this);
        var $deleteBtn = $(opt.deleteBtn);
        var $item = $list.children(".am-row");
        var $itemInner = $item.children(".inner");
        var $touch, $touchInner;
        var length = $item.length;
        var index = [];
        var lockX = 0;
        var lockY = 0;
        var lockDelete = 0;
        var pageSensitive = 10; //check move start threshold
        var moveSensitive = 10; //check move x / y threshold
        var openSensitivePercent = 25; //set open percent
        var x, y, _x, _y, movePercent, moveDistance;
        init();

        function init() {
            //绑定inner事件
            $itemInner
                .off("touchstart.listdrag touchmove.listdrag touchend.listdrag")
                .on("touchstart.listdrag", fnInnerTouchStart)
                .on("touchmove.listdrag", fnInnerTouchMove)
                .on("touchend.listdrag", fnInnerTouchEnd);

            //绑定删除按键事件
            $deleteBtn
                .off("touchend.listdrag")
                .on("touchend.listdrag", fnDelBtnTouchEnd);

            setSelect();
            setHead();
        }

        //item touchstart事件
        function fnInnerTouchStart(e) {
            //set control html & bing event
            $.settouch.init(e);
            x = $.touchX;
            y = $.touchY;
            $touch = $(this).parent(".am-row");
            $touchInner = $touch.children("div.inner");
            //disible css -webkit-transform
            $touch.addClass("am-active");
            //reset movePercent
            movePercent = 0;
            //check current am-on
            if ($touch.hasClass("am-on")) {
                lockX = 1;
                listClose();
                $touch.removeClass("am-on am-active");
            } else {
                if ($item.filter(".am-on").length > 0) {
                    $item.removeClass("am-on");
                    listClose();
                }
            }
            setControl();
        }

        //item touchmove事件
        function fnInnerTouchMove(e) {
            $.settouch.init(e);
            _x = $.touchX;
            _y = $.touchY;
            //check move x/y
            if ((y - _y > pageSensitive || _y - y > pageSensitive) && lockX === 0 && lockY === 0) {
                lockX = 1;
            } else
            if ((x - _x > pageSensitive) && (y - _y < pageSensitive || _y - y < pageSensitive) && lockX === 0 && lockY === 0) {
                lockY = 1;
            }
            //set move animate
            if (!lockX && (x - _x > pageSensitive)) {
                moveDistance = x - _x;
                //check moveDistance > openSensitivePercent set move slowly
                if ((moveDistance / $.winW * 100) > openSensitivePercent) {
                    moveDistance = $.winW * 2 / Math.PI * Math.atan(0.8 * moveDistance / $.winW) + $.winW * openSensitivePercent / 100 / 2;
                }
                var x = -1 * moveDistance;
                $touchInner.css({
                    "-webkit-transform": "translate3d(" + x + "px,0,0)",
                    "-moz-transform": "translate3d(" + x + "px,0,0)",
                    "transform": "translate3d(" + x + "px,0,0)"
                });
                movePercent = moveDistance / $.winW * 100;
            }
        }

        //item touchend事件
        function fnInnerTouchEnd() {
            $touch.removeClass("am-active");
            //set inner move
            if (movePercent > openSensitivePercent && lockX === 0) {
                listOpen();
            } else if (movePercent < openSensitivePercent && lockX === 0) {
                listClose();
            }
            //reset lock
            lockX = 0;
            lockY = 0;
        }

        //删除按键touchmove事件
        function fnDelBtnTouchEnd() {
            //touchmoved checking & not current
            if ($.touchMoved || $item.eq(0).hasClass("listdrag-select")) {
                return false;
            }
            //删除按键首次点击
            if (!lockDelete) {
                lockDelete = 1;
                //显示控制按键
                $.amHeader.find("div.listDragHead").addClass("am-on");
                $list.addClass("listdrag-select");
            }
            //删除按键二次点击
            else {
                //无任何选中
                if (!$item.find("label.am-row>span.am-on").length) {
                    opt.onNoSelect();
                }
                //有删除选中
                else {
                    lockDelete = 0;
                    index.length = 0;
                    for (var i = 0; i < length; i++) {
                        if ($item.eq(i).find("label.am-row>span").hasClass("am-on")) {
                            index.push(i);
                            $item.eq(i).fnGetBoxSize();
                            $item.eq(i).css({
                                height: $item.eq(i).data("height")
                            });
                            $item.eq(i).addClass("listdrag-delete");
                        }
                    }
                    setTimeout(function() {
                        $item.find("label.am-row>span.am-on").parent().parent().remove();
                        itemDelete();
                    }, $.globalAnimateSpeed);
                }
            }
        }

        //设置滑动后控制按键
        function setControl() {
            if ($touch.find("div.control").length) {
                return false;
            }
            $touch.append(opt.controlHtml);
            $touch.find("div.control a.delete").off("touchend").on("touchend", function() {
                if ($.touchMoved) {
                    return;
                }
                //set animate
                $touch.css({
                    height: $touch.height()
                });
                //set index
                index.length = 0;
                index.push($touch.index());
                setTimeout(function() {
                    $touch.addClass("listdrag-delete");
                });
                setTimeout(function() {
                    $touch.remove();
                    itemDelete();
                }, $.globalAnimateSpeed);
            });
        }

        //设置多选控制按键
        function setSelect() {
            for (var i = 0; i < length; i++) {
                if (!$item.eq(i).children("label ").length) {
                    $item.eq(i).append(opt.selectHtml);
                }
            }
            $item.find("label.am-row").fnChecked();
            if (!$(".listDragHead").length) {
                $.amHeader.append(opt.headerHtml);
            }
        }

        //头部控制按键绑定事件(全选，取消)
        function setHead() {
            $.amHeader.find("div.listDragHead a.select").off("touchend.listdrag").on("touchend.listdrag", function() {
                //touchmoved checking
                if (!$.touchMoved) {
                    $item.find("label.am-row>span").addClass("am-on");
                }
            });
            $.amHeader.find("div.listDragHead a.cancel").off("touchend.listdrag").on("touchend.listdrag", function() {
                //touchmoved checking
                if (!$.touchMoved) {
                    selectReset();
                }
            });
        }

        //取消全选
        function selectReset() {
            lockDelete = 0;
            $list.removeClass("listdrag-select");
            $item.removeClass("am-on");
            $.amHeader.find("div.listDragHead").removeClass("am-on");
            setTimeout(function() {
                $item.find("label.am-row>span").removeClass("am-on");
            }, $.globalAnimateSpeed);
            opt.onReturn();
        }

        //item左滑开放
        function listOpen() {
            $touchInner.removeAttr("style");
            $touch.addClass("am-on");
            opt.onDraged();
        }

        //item左滑关闭
        function listClose() {
            $touchInner.removeAttr("style");
            $touch.removeClass("am-on");
            opt.onReturn();
        }

        //item删除
        function itemDelete() {
            $item = $list.children(".am-row");
            length = $item.length;
            selectReset();
            opt.onDelete(index);
            $.scrollY[0].refresh();
        }
    });
};

//fnNotice
$.fn.fnNotice = function(options) {
    var defaults = {
        msg: "", //默认无消息
        href: "", //默认无链接
        time: 4000, //默认显示时间4秒
        color: "am-color-black", //默认为黑色样式
        destroy: false
    };
    var opt = $.extend({}, defaults, options);
    init();

    function init() {
        //repeat checking
        if (!$("#am-notice").length && opt.msg.length !== 0) {
            noticeShow();
        } else {
            //if has then delete
            destroy();
            //if have msg ths replay
            if (opt.msg.length !== 0) {
                setTimeout(noticeShow, 300);
            }
        }
    }

    //notice显示方法
    function noticeShow() {
        var innerHtml;
        //检测是否含有链接
        if (opt.href) {
            innerHtml = "<div class='am-notice " + opt.color + "' id='am-notice'><a href='" + opt.href + "'>" + opt.msg + "</a></div>";
        } else {
            innerHtml = "<div class='am-notice " + opt.color + "' id='am-notice'>" + opt.msg + "</div>";
        }
        $.htmlBody.append(innerHtml);
        //显示
        $.fnNoticeShowTimeOut = setTimeout(function() {
            $("#am-notice").addClass("am-on");
            //内容超出一行改为左对齐
            if ($("#am-notice").height() > 50) {
                $("#am-notice").addClass("am-align-left");
            }
        }, 20);
        //setTimeout notice hide
        $.fnNoticeHideTimeOut = setTimeout(function() {
            $("#am-notice").removeClass("am-on");
        }, opt.time);
        //setTimeout notice destroy
        $.fnNoticeDestoryTimeOut = setTimeout(function() {
            $("#am-notice").remove();
        }, opt.time + 300);
    }

    //notice销毁方法
    function destroy() {
        clearTimeout($.fnNoticeShowTimeOut);
        clearTimeout($.fnNoticeHideTimeOut);
        clearTimeout($.fnNoticeDestoryTimeOut);
        $.fnNoticeHideTimeOut = setTimeout(function() {
            $("#am-notice").removeClass("am-on");
        }, 0);
        $.fnNoticeDestoryTimeOut = setTimeout(function() {
            $("#am-notice").remove();
        }, 300);
    }
};

//fnNoticeBar
$.fn.fnNoticeBar = function(options) {
    if (!$(".am-notice-bar").eq(0).length) return;
    var defaults = {
        onClose: function() {}
    };
    var opt = $.extend({}, defaults, options);
    var $bar = $(".am-notice-bar").eq(0);
    var $close = $bar.children("del");
    var $notice = $bar.find("p");
    init();

    function init() {
        checkPlay();
        $close.off("touchend.noticebar").on("touchend.noticebar", fnClose);
    }

    //检测是否超出一行滚动
    function checkPlay() {
        if ($notice.width() > $notice.parent("a").width()) {
            //速度固定，根据内容长度生成滚动所需时间
            var speed = $notice.width() / $notice.parent("a").width() * 15;
            $notice.css({
                "-webkit-animation-duration": speed + "s",
                "-moz-animation-duration": speed + "s",
                "animation-duration": speed + "s"
            });
        }
        setStyle();
        $bar.addClass("play");
    }

    //设置滚动样式
    function setStyle() {
        var style = "<style>@-webkit-keyframes noticeBarPlay {";
        style += "0% { -webkit-transform:translate3d(" + $.winW + "px,0,0);}";
        style += "100% { -webkit-transform:translate3d(-100%,0,0);}";
        style += "}</style>";
        $.htmlBody.append(style);
    }

    //关闭事件
    function fnClose() {
        $bar.remove();
        $.fn.fnBodyHeight();
        $.scrollY[0].refresh();
        opt.onClose();
    }
};

//fnPageLoad
$.fn.fnPageLoad = function(state, msg) {
    $(".am-pageload").remove();
    if (!msg) {
        msg = ""
    }
    if (state === 0) { //用于隐藏浮层
        closeRander();
    } else if (state === 1) { //用于加载中
        $.htmlBody.append("<div class='am-pageload am-on'><span></span><p>" + msg + "</p></div>");
    } else if (state === 2) { //用于产品详情页面投资记录加载
        $.htmlBody.append("<div class='am-pageload am-sm am-on'><span></span><p>" + msg + "</p></div>");
    } else if (state === 3) { //用于网络异常
        $.htmlBody.append("<div class='am-pageload am-on am-disable'><span></span><p>网络异常，点击屏幕重试</p></div>");
    }

    //循环检测loading层是否关闭
    function closeRander() {
        var $pageload = $(".am-pageload");
        $pageload.remove();
        if ($pageload.length) {
            setTimeout(closeRander, 1000 / 60);
        }
    }
};

//fnPopup
$.fn.fnPopup = function(options) {
    var defaults = {
        msg: "", //显示消息
        type: "alert", //默认弹窗类型
        icon: "", //弹窗图标
        btnComfirmName: "确认", //确认按钮文字
        btnCancelName: "取消", //取消按钮文字
        btnSelectList: [{ //定义按钮组
            "id": "", //id
            "btnName": "", //按钮名
            "btnColor": "" //颜色样式
        }],
        promptInner: "",
        promptHeight: "",
        customHtml: "",
        shareList: -1,
        //callback notes-----------------------//
        onCancel: function() {},
        onComfirm: function() {},
        onPasscode: function() {},
        onPromptLoad: function() {},
        onForgetPwd: function() {},
        onShareLoad: function() {},
        onCustomLoad: function() {},
        onSelect: function() {}
    };
    var opt = $.extend({}, defaults, options);
    var promptHeight = opt.promptHeight + 240 > $.winH ? $.winH - 240 : opt.promptHeight;
    var popId;
    var type;
    init();

    function init() {
        //touchmoved checking
        if ($.touchMoved) {
            return false;
        }
        //popup type set
        if (opt.type === 'alert') {
            type = 1;
        } else if (opt.type === 'confrim') {
            type = 2;
        } else if (opt.type === 'select') {
            type = 3;
        } else if (opt.type === 'passcode') {
            type = 4;
        } else if (opt.type === 'prompt') {
            type = 5;
        } else if (opt.type === 'share') {
            type = 6;
        } else if (opt.type === 'input') {
            type = 7;
        } else if (opt.type === 'custom') {
            type = 8;
        } else if (opt.type === 'middle') {
            type = 9;
        } else if (opt.type === 'slide') {
            type = 10;
        }
        showPopup();
    }
    //popup close
    function closePopup() {
        //reset preventDefault
        document.addEventListener('touchmove', $.preventDefault, { passive: false });
        //disable popbtn double click 
        $("#" + popId).find(".am-popbtn,.am-btn").off("touchend.popBtn");
        //hide pop window
        $("#" + popId).removeClass("am-on");
        //body pointer reset
        setTimeout(function() {
            $("#" + popId).remove();
        }, $.globalAnimateSpeed + 200);
    }
    //popup show
    function showPopup() {
        popId = "pop-" + Math.floor(Math.random() * 10000000000 + 1);
        var innerHtml;
        var KBheight = $.winW >= 768 ? $.winW / 3 : $.winW / 1.46;
        //type alert
        if (type === 1) {
            innerHtml = "<div class='am-pop am-alert' id='" + popId + "'><div class='popBg'></div><div class='inner'><h6><span>" + opt.msg + "</span></h6><a class='am-popbtn am-submit'>" + opt.btnComfirmName + "</a></div></div>";
            $.htmlBody.append(innerHtml);
        } else
        //type confrim
        if (type === 2) {
            innerHtml = "<div class='am-pop am-confrim' id='" + popId + "'><div class='popBg'></div><div class='inner'><h6><span>" + opt.msg + "</span></h6><a class='am-popbtn am-cancel'>" + opt.btnCancelName + "</a><a class='am-popbtn am-submit'>" + opt.btnComfirmName + "</a></div></div>";
            $.htmlBody.append(innerHtml);
        } else
        //type select
        if (type === 3) {
            var length = opt.btnSelectList.length;
            innerHtml = "<div class='am-pop am-select' id='" + popId + "'><div class='popBg'></div><div class='inner'>";
            if (opt.msg !== "") {
                innerHtml += "<h6><span>" + opt.msg + "</span></h6>";
            }
            innerHtml += "<div>";
            for (var i = 0; i < length; i++) {
                //opt.color checking
                if (opt.btnSelectList[i].btnColor) {
                    innerHtml += "<a id='" + opt.btnSelectList[i].id + "' class='am-popbtn am-submit " + opt.btnSelectList[i].btnColor + "'><span>" + opt.btnSelectList[i].btnName + "</span></a>";
                } else {
                    innerHtml += "<a id='" + opt.btnSelectList[i].id + "' class='am-popbtn am-submit'><span>" + opt.btnSelectList[i].btnName + "</span></a>";
                }
            }
            innerHtml += "</div><a class='am-popbtn am-cancel'><span>取消</span></a></div></div>";
            $.htmlBody.append(innerHtml);
        } else
        //type passcode
        if (type === 4) {
            innerHtml = "<div class='am-pop am-popPasscode' id='" + popId + "'><div class='popBg'></div><div class='inner'><a class='am-popbtn am-close'>X</a><h6><span>" + opt.msg + "</span></h6><div class='code'><span></span><span></span><span></span><span></span><span></span><span></span></div><a class='am-forget-pwd'>忘记交易密码？</a></div><div class='am-keyboard number' style='height:" + KBheight + "px'><div class='am-g'><h6><span class='am-icon-security2 am-icon-36'></span>鲸钱包安全键盘</h6></div><div class='am-g'><a class='am-btn am-popbtn btn-n1 nozoom'>1</a><a class='am-btn am-popbtn btn-n2 nozoom'>2</a><a class='am-btn am-popbtn btn-n3 nozoom'>3</a><a class='am-btn am-popbtn btn-n4 nozoom'>4</a><a class='am-btn am-popbtn btn-n5 nozoom'>5</a><a class='am-btn am-popbtn btn-n6 nozoom'>6</a><a class='am-btn am-popbtn btn-n7 nozoom'>7</a><a class='am-btn am-popbtn btn-n8 nozoom'>8</a><a class='am-btn am-popbtn btn-n9 nozoom'>9</a><a class='am-btn am-popbtn nozoom btnFnNull'></a><a class='am-btn am-popbtn btn-n0 nozoom'>0</a><a class='am-btn am-popbtn btnFnDelete nozoom'></a></div></div></div>";
            $.htmlBody.append(innerHtml);
            $("#" + popId).attr("pass", "");
        } else
        //type prompt
        if (type === 5) {
            innerHtml = "<div class='am-pop am-popPrompt' id='" + popId + "'><div class='popBg'></div><div class='inner'><span class='" + opt.icon + "'></span><h6><span>" + opt.msg + "</span></h6><div class='prompt-inner' style='height:" + promptHeight + "px'></div><a class='am-popbtn am-cancel'>" + opt.btnCancelName + "</a><a class='am-popbtn am-submit'>" + opt.btnComfirmName + "</a></div></div>";
            $.htmlBody.append(innerHtml);
            opt.onPromptLoad(popId);
            //add preventDefault
            document.removeEventListener('touchmove', $.preventDefault, { passive: false });
        } else
        //type share
        if (type === 6) {
            innerHtml = "<div class='am-pop am-popShare' id='" + popId + "'><div class='popBg'></div><div class='inner'><strong class='my'>我的邀请二维码</strong><div class='code'><span></span><p class='am-xs am-align-center am-color-black1'>扫一扫上面的二维码，加入鲸钱包</p></div><strong class='share'>分享到</strong><div class='list am-g-4'><a class='am-popbtn iconWechat'><span>微信好友</span></a><a class='am-popbtn iconWxCircle'><span>朋友圈</span></a><a class='am-popbtn iconQQ'><span>QQ好友</span></a><a class='am-popbtn iconMessage'><span>短信</span></a></div></div></div>";
            $.htmlBody.append(innerHtml);
            for (var i = 0; i < opt.shareList.length; i++) {
                if (opt.shareList[i]) {
                    $("#" + popId).find(".am-popbtn").eq(i).addClass("am-on");
                }
            }
            opt.onShareLoad();
        } else
        //type input
        if (type === 7) {
            innerHtml = "<div class='am-pop am-popInput' id='" + popId + "'><div class='popBg'></div><div class='inner'><h6>" + opt.title + "</h6><span>" + opt.desc + "</span><input type='text' /><a class='am-popbtn am-cancel'>" + opt.btnCancelName + "</a><a class='am-popbtn am-submit'>" + opt.btnComfirmName + "</a></div></div>";
            $.htmlBody.append(innerHtml);
            for (var i = 0; i < opt.shareList.length; i++) {
                if (opt.shareList[i]) {
                    $("#" + popId).find(".am-popbtn").eq(i).addClass("am-on");
                }
            }
            setTimeout(function() {
                $("#" + popId).find("input").focus();
            });
        } else
        //type custom
        if (type === 8) {
            innerHtml = "<div class='am-pop am-popCustom' id='" + popId + "'><div class='popBg'></div><div class='inner " + opt.customClass + "'><h6>" + opt.msg + "</h6>" + opt.customHtml + "<a class='am-popbtn am-cancel am-btn-active'><span class='am-icon-close'></span></a></div></div>";
            $.htmlBody.append(innerHtml);
            opt.onCustomLoad(popId);
            //add preventDefault
            document.removeEventListener('touchmove', $.preventDefault, { passive: false });
        } else
        //type middle
        if (type === 9) {
            innerHtml = "<div class='am-pop am-popMiddle' id='" + popId + "'><div class='inner " + opt.customClass + "'>" + opt.customHtml + "<a class='am-popbtn am-cancel'><span class='am-icon-close-w'></span></a></div><div class='popBg'></div></div>";
            $.htmlBody.append(innerHtml);
            opt.onCustomLoad(popId);
            //add preventDefault
            document.removeEventListener('touchmove', $.preventDefault, { passive: false });
        } else
        //type slide //only use WX!!!!!
        if (type === 10) {
            innerHtml = "<div class='am-pop am-slide' id='" + popId + "'><div class='popBg'></div><div class='inner'><div class='prompt-inner' style='height:" + opt.promptHeight + "px'></div><a class='am-popbtn am-close'>X</a></div></div>";
            $.htmlBody.append(innerHtml);
            opt.onPromptLoad(popId);
        }
        //set btn cancel
        if (opt.btnCancelName === "") {
            $("#" + popId).addClass("am-noCancel");
        }
        if (opt.btnSubmitName === "") {
            $("#" + popId).addClass("am-noSubmit");
        }
        if ((type === 6) && $("#" + popId).children(".popBg").length) {
            $("#" + popId).children(".popBg").off("touchend.popBtn").on("touchend.popBtn", function() {
                opt.onCancel();
                closePopup();
            });
        }
        //bind btn touch color
        $("#" + popId).find(".am-popbtn").fnBtnTouch();
        //bind popup inner btn click
        btnCallBack(popId);
        //for ios keyboard auto release
        $.ambody.find(".am-input").blur();
        //popup show
        rAF(function() {
            $("#" + popId).addClass("am-on");
        });
    }
    //set popup inner btn click
    function btnCallBack() {
        var index;
        $("#" + popId).find(".am-popbtn,.am-forget-pwd").off("touchend.popBtn").on("touchend.popBtn", function() {
            //touchmoved checking
            if ($.touchMoved) {
                return false;
            }
            //callback type alert
            if (type === 1) {
                if ($(this).hasClass("am-submit")) {
                    opt.onComfirm();
                }
                closePopup();
            } else
            //callback type comfirm
            if (type === 2) {
                if ($(this).hasClass("am-submit")) {
                    opt.onComfirm();
                } else if ($(this).hasClass("am-cancel")) {
                    opt.onCancel();
                }
                closePopup();
            } else
            //callback type select
            if (type === 3) {
                index = $(this).index();
                if ($(this).hasClass("am-submit")) {
                    opt.onSelect(opt.btnSelectList[index]);
                } else if ($(this).hasClass("am-cancel")) {
                    opt.onCancel();
                }
                closePopup();
            } else
            //callback type passcode
            if (type === 4) {
                index = $("#" + popId).attr("pass").length + 1;
                var current;
                //key forget password
                if ($(this).hasClass("am-forget-pwd")) {
                    closePopup();
                    opt.onForgetPwd();
                } else
                //key number
                if (!$(this).hasClass("btnFnNull") && !$(this).hasClass("btnFnDelete") && $(this).parent().parent().hasClass("am-keyboard")) {
                    current = $(this).text();
                    //set current code
                    $("#" + popId).attr("pass", $("#" + popId).attr("pass") + current);
                    //show current code
                    $("#" + popId).find(".code span").eq(index - 1).html("&#8226;");
                    //finished checking
                    if (index === 6) {
                        //off click
                        $("#" + popId).find(".am-popbtn,.am-btn").off("touchend.popBtn");
                        //callback
                        $("#" + popId).find(".code").addClass("am-color-blue");
                        setTimeout(function() {
                            opt.onPasscode($("#" + popId).attr("pass"));
                            //code reset
                            $("#" + popId).find(".code>span").text("");
                            $("#" + popId).find(".code").removeClass("am-color-blue");
                            $("#" + popId).attr("pass", "");
                            //close popup
                            closePopup();
                        }, 250);
                    }
                } else
                //key delete
                if ($(this).hasClass("btnFnDelete")) {
                    index -= 2;
                    var tempCode = $("#" + popId).attr("pass").substring(0, index);
                    $("#" + popId).attr("pass", tempCode);
                    $("#" + popId).find(".code>span").eq(index).text("");
                } else
                //key close
                if ($(this).parent().hasClass("inner")) {
                    //code clear
                    $("#" + popId).find(".code>span").text("");
                    $("#" + popId).attr("pass", "");
                    //callback
                    opt.onCancel();
                    //popup close
                    closePopup();
                }
            } else
            //callback type prompt
            if (type === 5) {
                if ($(this).hasClass("am-submit")) {
                    if (opt.onComfirm() !== false) {
                        closePopup();
                    }
                } else if ($(this).hasClass("am-cancel")) {
                    opt.onCancel();
                    closePopup();
                }
            } else
            //callback type share
            if (type === 6) {
                if ($(this).hasClass("am-popbtn") && $(this).hasClass("am-on")) {
                    var id = $(this).index();
                    opt.onComfirm(id);
                    closePopup();
                }
            } else
            //callback type input
            if (type === 7) {
                if ($(this).hasClass("am-submit")) {
                    var val = $("#" + popId).find("input").eq(0).val();
                    opt.onComfirm(val);
                } else if ($(this).hasClass("am-cancel")) {
                    opt.onCancel();
                }
                closePopup();
            } else
            //callback type custom
            if (type === 8) {
                if ($(this).hasClass("am-submit")) {
                    opt.onComfirm(val);
                } else if ($(this).hasClass("am-cancel")) {
                    opt.onCancel();
                }
                closePopup();
            } else
            //callback type custom
            if (type === 9) {
                if ($(this).hasClass("am-submit")) {
                    opt.onComfirm(val);
                } else if ($(this).hasClass("am-cancel")) {
                    opt.onCancel();
                }
                closePopup();
            } else
            //callback type slide
            if (type === 10) {
                closePopup();
            }
            //防止点击穿透弹层背部有link
            return;
        });
    }
};
$.fn.fnPopup.loadInner = function(options) {
    var defaults = {
        id: "",
        html: "",
        onPromptLoadEnd: function() {}
    };
    var opt = $.extend({}, defaults, options);
    init();

    function init() {
        $("#" + opt.id).find(".prompt-inner").html(opt.html);
        opt.onPromptLoadEnd();
    }
};
$.fn.fnPopupClose = function() {
    //reset preventDefault
    document.addEventListener('touchmove', $.preventDefault, { passive: false });
    var $this = $("body>.am-pop");
    $this.removeClass("am-on");
    setTimeout(function() {
        $this.remove();
    }, $.globalAnimateSpeed + 200);
};

//fnPriceLongTouch
$.fn.fnPriceLongTouch = function(options) {
    if (!$(this).length) return;
    var defaults = {
        minVal: 4, //最小值
        maxVal: 12, //最大值
        curVal: 8, //默认值
        stepVal: 0.01, //最小变化值
        onChanged: function(val) {}, //改变值后回调
        onTouchEnd: function(val) {}, //长按松开回调
        onValMin: function() {}, //小于最小值回调
        onValMax: function() {} //大于最大值回调
    };
    var opt = $.extend({}, defaults, options);
    var $btn = $(this).children(".am-btn");
    var $val = $(this).find(".am-input");
    var timeOffsetL0, timeS;
    var longLock = 1;
    var myTime = new Date();
    var stepVal = Number(opt.stepVal.toFixed(2));
    var val = Number(opt.minVal.toFixed(2));
    var timeOut, stepTime;
    var type;
    init();

    function init() {
        $val.val(opt.curVal);
        $btn
            .off("touchstart.longtouch touchend.longtouch")
            .on("touchstart.longtouch", fnBtnStart)
            .on("touchend.longtouch", fnBtnEnd);
        $val
            .off("input.longtouch")
            .on("input.longtouch", fnValInput);
    }

    //输入框值改变事件
    function fnValInput() {
        val = Number($val.val()) || opt.curVal;
        opt.onChanged(val);
    }

    //按钮开始点击事件
    function fnBtnStart(e) {
        val = Number($val.val());
        stepVal = Number(opt.stepVal.toFixed(2));
        if ($(this).hasClass("am-btnAdd")) {
            type = 1;
        } else {
            type = 0;
        }
        //清空后首次点击后回归到默认值
        if (!val && type === 1) {
            val = opt.curVal - stepVal;
        } else if (!val && type === 0) {
            val = opt.curVal + stepVal;
        }
        //设置val
        fnSetVal();
        myTime = new Date();
        timeS = myTime.getTime();
        //首次点击后激活长按的间隔时间
        timeOut = setTimeout(fnInterval, 500);
        //禁用Android系统长按事件
        e.preventDefault();
    }

    //按钮结束点击事件
    function fnBtnEnd() {
        myTime = new Date();
        timeOffsetL0 = myTime.getTime() - timeS;
        longLock = 1;
        clearTimeout(timeOut);
        //判断最大最小后不回调
        if (val !== opt.minVal && val !== opt.maxVal) {
            opt.onTouchEnd(val);
        }
    }

    //长按interval事件
    function fnInterval() {
        myTime = new Date();
        timeOffsetL0 = (myTime.getTime() - timeS);
        //曲线变化公式
        stepTime = 1 / Math.pow(timeOffsetL0 / 1000, 1.2) * 100;
        //最小间隔为屏幕刷新率
        if (stepTime < 1000 / 60) {
            stepTime = 1000 / 60;
        }
        fnSetVal();
        timeOut = setTimeout(fnInterval, stepTime);
    }

    //设置当前值
    function fnSetVal() {
        if (!$.touchMoved) {
            //判断加减按键
            if (type) {
                val += stepVal;
            } else {
                val -= stepVal;
            }
            //判断最大最小值
            if (val < opt.minVal) {
                val = opt.minVal;
                opt.onValMin();
            } else if (val > opt.maxVal) {
                val = opt.maxVal;
                opt.onValMax();
            } else {
                //设置数字并回调
                val = Number(val.toFixed(2));
                $val.val(val);
                opt.onChanged(val);
            }
        }
    }
};

//下拉刷新回调方法，可用同名新方法覆盖此默认值
$.scrollPullDown = function() {
    console.log("refreshing");
    $.scrollY[0].pullDownComplete(function() {
        console.log("loaddata");
    });
};

//上拉加载回调方法，可用同名新方法覆盖此默认值
$.scrollPullUp = function(callback) {
    console.log("loading");
    $.scrollY[0].pullUpComplete(function() {
        console.log("loaddata");
    });
};

//fnScrollX
$.fn.fnScrollX = function(options) {
    var defaults = {
        num: false, //[0,1,2,3]数组选择需要显示的列，可跳跃
        xIndex: false, //重设后的默认显示列
        hideNext: false //设置滚动时是否隐藏临近项
    };
    var opt = $.extend({}, defaults, options);
    var $scrollXPanel = $(".scrollX0-panel");
    var $scrollY = $.ambodyInner.children("div[class*=scrollY]");
    var scrollXLock = 0;
    init();

    function init() {
        //reset scrollX length for fnScrollPanel
        // 20170209
        // if (opt.num === false) {
        //     $.scrollX.length = 0;
        // }
        //无横向滚动页面dom设置
        if (!$scrollY.length) {
            $.ambodyInner.wrapInner("<div class='scrollY0 am-con am-fullsize' />");
            $scrollY = $.ambodyInner.children("div[class*=scrollY]");
            $scrollY.wrapInner("<div class='scrollInner' />");
            $.ambodyScroll = $(".scrollY0>.scrollInner");
        }

        //定义横向页码
        if (!opt.num) { //无指定列参数时
            $.xPage = setArrow($scrollY.length);
        } else { //有指定列参数量
            $.xPage = opt.num;
        }

        //设置按键组当前页下划线
        if ($.xPage.length !== 1) {
            if (!$scrollXPanel.children("mark").length) {
                $scrollXPanel.append("<mark></mark>");
            }
        } else {
            $scrollXPanel.children("mark").remove();
        }

        //根据横向页码设置scrollX的宽度
        $.ambodyInner
            .attr({
                "class": "am-body-inner am-g-" + $.xPage.length
            })
            .css({
                "width": $.xPage.length + "00%"
            });
        //根据横向页码设置panel按键组宽度
        $scrollXPanel
            .removeClass("am-g-1 am-g-2 am-g-3 am-g-4 am-g-5")
            .addClass("am-g-" + $.xPage.length);

        //初始化显示需要展示的列
        $scrollXPanel.children("a").hide();
        $scrollY.hide();
        for (var i = 0; i < $.xPage.length; i++) {
            $scrollXPanel.children("a").eq($.xPage[i]).show();
            $scrollY.eq($.xPage[i]).show();
        }

        //set new scroll
        if (!$.scrollX[0]) { //首次
            $.scrollX[0] = new IScroll(".am-body", {
                scrollX: true,
                scrollY: false,
                momentum: false,
                snap: true,
                snapThreshold: 0.2
            });
        } else { //再次，产品列表页登录前后切换
            if (opt.xIndex !== false) {
                $.xIndex = $.inArray(opt.xIndex, $.xPage);
            } else {
                $.xIndex = 0;
            }
            $.scrollX[0].goToPage($.xIndex, 0, 0);
            $.scrollX[0].refresh();
            setPanelBtn();
        }
        //设置是否显示下一项
        setShowNext();

        //首次绑定事件
        if (!$.ambody.hasClass("scrollX0")) {
            //绑定横向滚动事件
            $.ambody.addClass("scrollX0");
            $.scrollX[0].on("beforeScrollStart", beforeScrollStart);
            $.scrollX[0].on("scrollEnd", scrollEnd);
            $.scrollX[0].on("scroll", scroll);
            //绑定横向panel点击事件
            $scrollXPanel.children("a").off("touchend.scrollXPanel").on("touchend.scrollXPanel", function() {
                if (!$.touchMoved) {
                    for (i = 0; i < $.xPage.length; i++) {
                        if ($.xPage[i] === $(this).index()) {
                            $.xIndex = i;
                            break;
                        }
                    }
                    $.scrollX[0].goToPage($.xIndex, 0, 300);
                    setPanelBtn();
                    setShowNext();
                }
            });
        }
    }

    function scrollEnd() {
        $.xIndex = $.scrollX[0].currentPage.pageX;
        //unlock current scrollY
        if (scrollXLock) {
            scrollXLock = 0;
            var prevIndex = $scrollY.filter(".am-disable").index();
            if (prevIndex !== -1) {
                $scrollY.eq(prevIndex).removeClass("am-disable");
                $.scrollY[prevIndex].enable();
            }
        }
        setPanelBtn();
        setShowNext();
    }

    function scroll() {
        //lock current scrollY and unlock siblings
        if (Math.abs($.scrollX[0].x + $.xIndex * $.winW) > 1 && !scrollXLock) {
            scrollXLock = 1;
            for (var i = 0; i < $.scrollY.length; i++) {
                if (i === $.xPage[$.xIndex]) {
                    $.scrollY[i].disable();
                    $scrollY.eq(i).addClass("am-disable");
                } else {
                    $.scrollY[i].enable();
                    $scrollY.eq(i).removeClass(".am-disable");
                }
            }
        }
    }

    function beforeScrollStart() {
        if ($scrollY.eq($.xPage[$.xIndex]).hasClass("am-disable")) {
            $.scrollY[$.xPage[$.xIndex]].enable();
            $scrollY.eq($.xPage[$.xIndex]).removeClass(".am-disable");
        }
    }

    function setArrow(l) {
        var n = [];
        for (var i = 0; i < l; i++) {
            n[i] = i;
        }
        return n;
    }

    function setPanelBtn() {
        $scrollXPanel.children("a")
            .eq($.xPage[$.xIndex])
            .addClass("am-on")
            .siblings()
            .removeClass("am-on");

        $scrollXPanel.children("mark")
            .css({
                "-webkit-transform": "translate3d(" + $.xIndex + "00%,0,0)",
                "-moz-transform": "translate3d(" + $.xIndex + "00%,0,0)",
                "transform": "translate3d(" + $.xIndex + "00%,0,0)"
            });
    }

    function setShowNext() {
        if (opt.hideNext) {
            $scrollY.eq($.xPage[$.xIndex]).css({
                visibility: "visible",
                opacity: 1
            }).siblings().css({
                visibility: "hidden",
                opacity: 0
            });
        }
    }
};

//fnScrollY
$.fn.fnScrollY = function() {
    var touchSensitive = 5;
    init();

    function init() {
        //绑定上下拉出webview事件
        $(document).off("touchmove.moveOutWebview").on("touchmove.moveOutWebview", moveOutWebview);
        //set scrollY
        $("div[class*=scrollY]").each(function(i) {
            var $up, $down;
            var scrolly, scrollMaxy;
            var $scrollY = $(this);

            //set scrollY and check repeat  
            if ($.scrollY[i]) {
                $.scrollY[i].destroy();
                $.scrollY[i] = null;
            }
            $.scrollY[i] = new IScroll(".scrollY" + i);

            //set pulldown/pullup dom and check repeat
            if (!$scrollY.children(".scrollInner").children(".am-pullUp").length) {
                $scrollY.children(".scrollInner").append($.pullUpHtml);
            }
            if (!$scrollY.children(".scrollInner").children(".am-pullDown").length) {
                $scrollY.children(".scrollInner").prepend($.pullDownHtml);
            }
            $up = $scrollY.children(".scrollInner").children(".am-pullUp");
            $down = $scrollY.children(".scrollInner").children(".am-pullDown");

            //bind scroll event
            $.scrollY[i].off("scroll", fnScrollYScroll);
            $.scrollY[i].on("scroll", fnScrollYScroll);
            //bind pulldown event
            $.scrollY[i].off("slideDown", fnScrollYSlideDown);
            $.scrollY[i].on("slideDown", fnScrollYSlideDown);
            //bind pullup event
            $.scrollY[i].off("slideUp", fnScrollYSlideUp);
            $.scrollY[i].on("slideUp", fnScrollYSlideUp);

            function fnScrollYScroll() {
                if (!$down.hasClass("loading")) {
                    $.sTop = scrolly = Math.round(this.y);
                    scrollMaxy = this.maxScrollY - scrolly;
                    var downHasClass = $down.hasClass("am-on");
                    var upHasClass = $up.hasClass("am-on");
                    if (scrolly >= $.pullDownSensitive && !downHasClass) {
                        $down.addClass("am-on");
                    } else if (scrolly < $.pullDownSensitive && scrolly > 0 && downHasClass) {
                        $down.removeClass("am-on");
                    }
                    if (scrollMaxy >= $.pullUpSensitive && !upHasClass) {
                        $up.addClass("am-on");
                    } else if (scrollMaxy < $.pullUpSensitive && scrollMaxy >= 0 && upHasClass) {
                        $up.removeClass("am-on");
                    }
                    dropDownLogo(scrolly, i);
                }
            }

            function fnScrollYSlideDown() {
                if (this.y > $.pullDownSensitive && $scrollY.children(".showPullDown").length) {
                    $(document).off("touchmove.moveOutWebview");
                    $.scrollY[i].disable();
                    $down.addClass("loading");
                    $.scrollY[i].scrollTo(0, $.pullDownSensitive, $.bounceTime);
                    $.scrollPullDown();
                }
            }

            function fnScrollYSlideUp() {
                if (this.maxScrollY - this.y > $.pullUpSensitive && $scrollY.children(".showPullUp").length) {
                    $(document).off("touchmove.moveOutWebview");
                    $up.removeClass("am-on");
                    if (!$up.hasClass("end")) {
                        $.scrollY[i].disable();
                        $up.addClass("loading");
                        $.scrollPullUp();
                    }
                }
            }

            $.scrollY[i].pullDown = function() {
                $scrollY.children(".scrollInner").addClass("showPullDown");
            };
            $.scrollY[i].pullDownComplete = function(callback) {
                setTimeout(function() {
                    console.log("refreshend");
                    $down.removeClass("am-on loading");
                    $.scrollY[i].scrollTo(0, 0, $.bounceTime * 0.5);
                    $.scrollY[i].enable();
                    $.scrollY[i].refresh();
                    $(document).on("touchmove.moveOutWebview", moveOutWebview);
                    setTimeout(function() {
                        callback();
                    }, $.bounceTime / 2);
                }, $.bounceTime);
            };
            $.scrollY[i].pullUp = function() {
                $scrollY.children(".scrollInner").addClass("showPullUp");
            };
            $.scrollY[i].pullUpComplete = function(callback) {
                setTimeout(function() {
                    console.log("loadend");
                    $up.removeClass("loading");
                    $.scrollY[i].enable();
                    $.scrollY[i].refresh();
                    $(document).on("touchmove.moveOutWebview", moveOutWebview);
                    setTimeout(function() {
                        callback();
                    });
                }, $.bounceTime + 250);
            };
        });
    }

    function dropDownLogo(y, i) {
        if (y > 1) {
            if (y < $.pullDownSensitive) {
                var y = $.pullDownSensitive - y;
                $("div.scrollY" + i).find(".am-pullDown span").eq(0).css({
                    "-webkit-transform": "translate3d(0," + y + "px,0)",
                    "-moz-transform": "translate3d(0," + y + "px,0)",
                    "transform": "translate3d(0," + y + "px,0)"
                });
            }
            if (y > $.pullDownSensitive) {
                if (!$("div.scrollY" + i).find(".am-pullDown").hasClass("am-on")) {
                    $("div.scrollY" + i).find(".am-pullDown").addClass("am-on");
                }
            } else {
                if ($("div.scrollY" + i).find(".am-pullDown").hasClass("am-on")) {
                    $("div.scrollY" + i).find(".am-pullDown").removeClass("am-on");
                }
            }
        }
    }

    function moveOutWebview(e) {
        $.settouch.init(e);
        var ty = $.touchY;
        if (ty <= touchSensitive || ty >= $.winH - touchSensitive) {
            //down moveout
            $.scrollY[$.xPage[$.xIndex]].touchCancel(e);
        }
    }
};

//fnSlideDown
$.fn.fnSlideDown = function(options) {
    if (!$(this).length) return;
    var defaults = {
        only: true, //only one line at one time
        onSlidedown: function( /*id,index,state*/ ) {}
            //id当前点击位置所在组的id
            //index当前点击位置所在本列表的index
            //state当前点击位置的状态，1为打开，0为关闭
    };
    var opt = $.extend({}, defaults, options);
    return this.each(function() {
        var $this = $(this);
        var $con = $this.next("div.am-slidedown-con");
        var $thisparent = $this.parent(".am-row");
        var index = $thisparent.index();
        var id = $thisparent.parent("div.am-slidedown").attr("id");
        var state;
        init();

        function init() {
            if ($this.parent("div.am-on").length) {
                index = $this.parent().index();
                state = 1;
                setTimeout(fnSlideEnd, $.globalAnimateSpeed);
            }
            //has slidedown checking
            if ($con.length) {
                //bind event
                $this.off("touchend.slidedown").on("touchend.slidedown", function() {
                    btnClick();
                });
            }
        }

        //下拉点击事件
        function btnClick() {
            if ($.touchMoved) return;
            if (!$thisparent.hasClass("am-on")) {
                if (opt.only) {
                    $thisparent.siblings().removeClass("am-on");
                }
                $thisparent.addClass("am-on");
                state = 1;
            } else {
                $thisparent.removeClass("am-on");
                state = 0;
            }
            setTimeout(fnSlideEnd, $.globalAnimateSpeed);
        }

        //切换动画完成事件
        function fnSlideEnd() {
            //刷新当前pageY滚动条
            $.scrollY[$.xIndex].refresh();
            //call back
            opt.onSlidedown(id, index, state);
        }
    });
};

//fnSlidePanel
$.fn.fnSlidePanel = function(options) {
    if (!$(".am-slide-panel-btn").length || !$(".am-slide-panel-con").length) return;
    var defaults = {
        onChanged: function( /*index*/ ) {}
    };
    var opt = $.extend({}, defaults, options);
    var $btnParent = $(".am-slide-panel-btn");
    var $conParent = $(".am-slide-panel-con");
    var $panelBtn = $btnParent.children("a");
    var $panelCon = $conParent.children(".am-con");
    var index = $btnParent.children(".am-on").eq(0).index() === -1 ? 0 : $btnParent.children(".am-on").index();
    var panelTop = $panelBtn.length ? Math.round($panelBtn.offset().top) : 0;
    var headerH = $.amHeader.height() || 0;
    var footerH = $.amFooter.height() || 0;
    var globalGap = 1;
    init();

    function init() {
        //设置默认显示状态
        $conParent.css({ "min-height": ($.winH - headerH - globalGap - footerH - $btnParent.height()) });
        $panelBtn.eq(index).addClass("am-on").siblings().removeClass("am-on");
        $panelCon.eq(index).addClass("am-on").siblings().removeClass("am-on");
        //绑定tab点击事件
        $panelBtn.off("touchend.slidepanel").on("touchend.slidepanel", function() {
            index = $(this).index();
            fnSetPanel(index);
        });
        //绑定滚动事件
        $.scrollY[0].off("scroll", fnScrollSlidePanel);
        $.scrollY[0].on("scroll", fnScrollSlidePanel);
        $.scrollY[0].refresh();
    }

    //面板切换事件
    function fnSetPanel(index) {
        if (!$panelBtn.eq(index).hasClass("am-on") && !$.touchMoved) {
            $panelBtn.eq(index).addClass("am-on").siblings().removeClass("am-on");
            $panelCon.eq(index).addClass("am-on").siblings().removeClass("am-on");
            //切换后刷新滚动条并重新定位btnCon
            $.scrollY[0].refresh();
            $.sTop = Math.round($.scrollY[0].y);
            var y = -1 * ($.sTop + panelTop - headerH - globalGap);
            $btnParent.css({
                "-webkit-transform": "translate3d(0," + y + "px,0)",
                "-moz-transform": "translate3d(0," + y + "px,0)",
                "transform": "translate3d(0," + y + "px,0)"
            });
            //在顶部时点击切换后自动滚动
            fnScrollUp();
            //callback
            opt.onChanged(index);
        }
    }

    //面板上下滚动事件
    function fnScrollSlidePanel() {
        //保持btnCon在屏幕顶部
        var y = -1 * ($.sTop + panelTop - headerH - globalGap);
        if (y >= 0) {
            $btnParent.css({
                "-webkit-transform": "translate3d(0," + y + "px,0)",
                "-moz-transform": "translate3d(0," + y + "px,0)",
                "transform": "translate3d(0," + y + "px,0)"
            });
        }
        //去掉btnCon定位数值
        else {
            $btnParent.css({
                "-webkit-transform": "translate3d(0,0,0)",
                "-moz-transform": "translate3d(0,0,0)",
                "transform": "translate3d(0,0,0)"
            });
        }
    }

    //面板切换后置顶事件
    function fnScrollUp() {
        $.scrollY[0].scrollTo(0, -1 * panelTop + headerH + globalGap, $.bounceTime * 0.5);
    }
};

//fnSlideRuler
$.fn.fnSlideRuler = function(options) {
    if (!$(this).length) return;
    var defaults = {
        //所有金额都是以万为单位
        minVal: 1, //最低起投额
        maxVal: 100, //最高起投额
        step: 1, //递增递减额度，可选范围:[1,0.1]
        msg: "", //卡尺右侧提示文字
        onChanged: function(val) {}, //每次改变金额
        onReady: function(val) {}, //初始化完成
        onClear: function() {} //清空输入框
    };
    var opt = $.extend({}, defaults, options);
    var $this = $(this);
    var maxVal = opt.maxVal;
    var minVal = opt.maxVal >= opt.minVal ? opt.minVal : opt.maxVal;
    var $input = $this.find(".am-input");
    var $inputClear = $input.prev(".am-input-clear");
    var $inputCon = $input.parents(".am-con");
    var $inner = $this.find(".inner");
    var $ruler;
    var length = maxVal - minVal;
    var itemWidth = 60;
    var valStep;
    var valMultiple = 10000;
    var x, _x;
    var scrollRuler;
    var scrollLock = 0;
    var scrollSpeed = 200;
    var valCurrent;
    init();

    function init() {
        var html = "<ul class='ruler'>";
        var tempVal = length >= 0 ? minVal : maxVal;

        //设定first li dom
        html += "<li class='first' style='width:" + ($.winW / 2 + 1) + "px'><span>向左滑动</span></li>";
        html += "";
        //设定中间li dom
        if (length >= 0) {
            for (var i = 0; i < length + 1; i++) {
                html += "<li style='width:" + itemWidth + "px;'><span>" + (parseInt(i) + tempVal) + "<em>万</em></span></li>";
            }
        }

        //加载&滚动条
        html += "</ul>";
        $inner.html(html);
        $input.after("<span class='am-icon-inputedit'></span>");
        $ruler = $inner.find(".ruler");
        $ruler.find("li:last-child").addClass("last").width($.winW / 2 + 1).append("<span>" + opt.msg + "</span>");
        $ruler.css({ "width": length * itemWidth + $.winW + 4 });

        setStep();

        //绑定事件
        $input.off("input.slideruler").on("input.slideruler", setInputChange);
        $inputClear.off("touchend.slideruler").on("touchend.slideruler", setInputClear);
        //ready init
        minVal !== 0 ? valCurrent = minVal : valCurrent = 0.0001;
        $input.val(valCurrent * valMultiple);
        opt.onReady(valCurrent);

        //判断min<=>max时
        if (opt.minVal > opt.maxVal) {
            $inner.addClass("am-disable");
            $inputCon.addClass("am-disable");
            return false;
        } else if (opt.minVal === opt.maxVal) {
            $inputCon.addClass("am-disable");
        }
        //执行滚动条
        $.scrollX[1] = new IScroll(".am-slideRuler .inner", {
            scrollX: true,
            scrollY: false,
            deceleration: 0.005
        });
        //绑定滚动事件
        $.scrollX[1].on("scroll", function() {
            x = this.x;
            setScroll();
        });
        $.scrollX[1].on("scrollStart", checkFirst);
        $.scrollX[1].on("scrollEnd", function() {
            x = this.x;
            setScrollEnd();
        });
    }

    //检测首次拖动
    function checkFirst() {
        $ruler.addClass("am-on"); //隐藏“向右滑动”提示
        $.scrollX[1].off("scrollStart", checkFirst); //解除首次拖动事件
    }

    //设置刻度线
    function setStep() {
        valStep = opt.step * valMultiple;
        $ruler.addClass("step" + valStep);
    }

    //滚动事件
    function setScroll() {
        if ($input.val() === "") {
            $inputClear.show();
        }
        setScrollVal();
        $input.val(valCurrent * valMultiple);
        opt.onChanged(valCurrent);
    }

    //滚动停止事件
    function setScrollEnd() {
        setScrollVal();
        setRulerPos(valCurrent);
        $input.val(valCurrent * valMultiple);
        opt.onChanged(valCurrent);
    }

    //设置刻度尺状态
    function setRulerPos(val) {
        x = -1 * (val - 1) * itemWidth + (minVal - 1) * itemWidth;
        $.scrollX[1].scrollTo(x, 0);
    }

    //设置当前值
    function setScrollVal() {
        x = $.scrollX[1].x;
        valCurrent = -1 * x / itemWidth + minVal;
        //检查移动刻度
        if (opt.step === 1) {
            valCurrent = Math.round(valCurrent);
        } else if (opt.step === 0.1) {
            valCurrent = parseFloat(valCurrent.toFixed(1));
        }
        checkValOffset();
    }

    //输入框修改事件
    function setInputChange() {
        //格式化后有非法字符时，重置输入框
        if ($input.val() !== $input.val().replace(/[^\d.]/g, '')) {
            $input.val($input.val().replace(/[^\d.]/g, ''));
        }
        valCurrent = Number($input.val()) / valMultiple;
        checkValOffset();
        setRulerPos(valCurrent);
        opt.onChanged(valCurrent);
    }

    //输入框清除事件
    function setInputClear() {
        valCurrent = 0;
        checkValOffset();
        setRulerPos(valCurrent);
        opt.onChanged(valCurrent);
        opt.onClear();
    }

    //检测超出范围
    function checkValOffset() {
        //小于等于最小值时
        if (valCurrent <= minVal) {
            valCurrent = minVal;
            //最小值为0时，设置显示1元
            if (minVal === 0) {
                valCurrent = 0.0001;
            }
        } else
        //大于最大值时
        if (valCurrent > maxVal) {
            valCurrent = maxVal;
        }
    }
};

//fnFixedTop
$.fn.fnFixedTop = function() {
    var $this = $(this);
    var scrollIndex = $this.parents("div[class*=scrollY]").index();
    var defaultTop = $this.offset().top;
    var headerH = $.amHeader.height() || 0;
    var offsetGap = -1;
    
    init();

    function init() {
        //绑定滚动事件
        $.sTop = $.scrollY[scrollIndex].y;
        $.scrollY[scrollIndex].off("scroll", fnScroll);
        $.scrollY[scrollIndex].on("scroll", fnScroll);
        fnScroll();
    }

    function fnScroll() {
        //保持在屏幕顶部
        var y = ($.sTop + defaultTop - headerH - offsetGap) * -1;
        if (y >= 0) {
            $this.css({
                "-webkit-transform": "translate3d(0," + y + "px,0)",
                "-moz-transform": "translate3d(0," + y + "px,0)",
                "transform": "translate3d(0," + y + "px,0)"
            });
        }
        //清除定位
        else {
            fnClearFixed();
        }
    }

    function fnClearFixed() {
        $this.css({
            "-webkit-transform": "translate3d(0,0,0)",
            "-moz-transform": "translate3d(0,0,0)",
            "transform": "translate3d(0,0,0)"
        });
    }

    this.refresh = function(){
        $.sTop = 0;
        fnClearFixed();
        fnScroll();
    }

    return this;
};

//page ready
var fnPageReady = function(callback) {
    document.addEventListener('touchmove', $.preventDefault, { passive: false });
    $.setmove.init();
    $.htmlBody = $("body");
    $.amHeader = $("div.am-header").eq(0) || "";
    $.amFooter = $.htmlBody.children(".am-pos-fixb").eq(0) || "";
    $.ambody = $("div.am-body").eq(0);
    $.fn.fnCheckDevice();
};
var fnPageLoad = function() {
    $.fn.fnBodyInner();
    $.fn.fnBodyHeight();
    $.fn.fnScrollX();
    $.fn.fnScrollY();
    fnPageInit();
};
var fnPageInit = function() {
    $("div.am-pos-fixb").eq(0).fnFooterTips();
    $.fn.fnBtnTouch();
    $.fn.fnKeyBoard.ready();
    $("label").fnChecked();
    $("input.am-input").fnInput();
    $("input.am-input").fnInputBlur();
    $("a.am-btnSwitch").fnBtnSwitch();
    $(".am-bg-img").fnBgImg();
    $("div.am-slidedown:not(.am-on)>.am-row>.am-row-title").fnSlideDown();
    $("div.am-dropdown>.am-row>.am-dropdown-inner").fnDropDown();
    $.amHeader.children("span.title.am-autosize").fnAutoTitle();
    $.amHeader.children("span.title").fnTitleToTop();
    // $("div.am-panel-con[data-scroll]").fnScrollPanel();
    // $(".am-con-btnPrice").fnPriceLongTouch();
    // $("a.am-btnVerifyCode").fnBtnVerifyCode();
    // $.fn.fnInputScroll();
    // $.fn.fnNoticeBar();
    // $.fn.fnIndexBar();
    // $.fn.fnSlidePanel();
};
fnPageReady();
